<?xml version="1.0" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"  xmlns:fpml="http://www.fpml.org/2005/FpML-4-2" exclude-result-prefixes="fpml" version="1.0">

<xsl:variable name="version">
<xsl:value-of select="/fpml:SWDML/@version"/>
</xsl:variable>

<xsl:variable name="productType">
<xsl:value-of select="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:swProductType"/>
</xsl:variable>

<xsl:variable name="FpMLVersion">
<xsl:value-of select="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/@version"/>
</xsl:variable>

<xsl:variable name="docsType">
<xsl:choose>

<xsl:when test="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:documentation/fpml:masterConfirmation/fpml:masterConfirmationType = 'Equity Options (AEJ)'">Equity Options (AEJ)</xsl:when>
<xsl:when test="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:documentation/fpml:masterConfirmation/fpml:masterConfirmationType = 'ISDA2005EquityAsiaExcludingJapanInterdealer'">Equity Options (AEJ)</xsl:when>

<xsl:when test="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:documentation/fpml:masterConfirmation/fpml:masterConfirmationType = 'Equity Options (Americas)'">Equity Options (Americas)</xsl:when>
<xsl:when test="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:documentation/fpml:masterConfirmation/fpml:masterConfirmationType = 'ISDA2004EquityAmericasInterdealer' and ($productType = 'Equity Share Option' or $productType = 'Equity Index Option')">Equity Options (Americas)</xsl:when>

<xsl:when test="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:documentation/fpml:masterConfirmation/fpml:masterConfirmationType = 'Equity Options (Europe)'">Equity Options (Europe)</xsl:when>
<xsl:when test="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:documentation/fpml:masterConfirmation/fpml:masterConfirmationType = '2004EquityEuropeanInterdealer'">Equity Options (Europe)</xsl:when>
<xsl:when test="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:documentation/fpml:masterConfirmation/fpml:masterConfirmationType = 'ISDA2007EquityEuropean'">Equity Options (Europe)</xsl:when>

<xsl:when test="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:documentation/fpml:masterConfirmation/fpml:masterConfirmationType = 'Equity Options (Japan)'">Equity Options (Japan)</xsl:when>
<xsl:when test="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:documentation/fpml:masterConfirmation/fpml:masterConfirmationType = 'ISDA2005EquityJapaneseInterdealer'">Equity Options (Japan)</xsl:when>

<xsl:when test="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:documentation/fpml:masterConfirmation/fpml:masterConfirmationType = 'Variance Swap (AEJ)'">Variance Swap (AEJ)</xsl:when>
<xsl:when test="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:documentation/fpml:masterConfirmation/fpml:masterConfirmationType = 'ISDA2007VarianceSwapAsiaExcludingJapan'">Variance Swap (AEJ)</xsl:when>

<xsl:when test="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:documentation/fpml:masterConfirmation/fpml:masterConfirmationType = 'Variance Swap (Americas)'">Variance Swap (Americas)</xsl:when>
<xsl:when test="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:documentation/fpml:masterConfirmation/fpml:masterConfirmationType = 'ISDA2004EquityAmericasInterdealer' and ($productType = 'Share Variance Swap' or $productType = 'Index Variance Swap')">Variance Swap (Americas)</xsl:when>
<xsl:when test="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:documentation/fpml:masterConfirmation/fpml:masterConfirmationType = 'ISDA2007VarianceSwapAmericas'">Variance Swap (Americas)</xsl:when>

<xsl:when test="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:documentation/fpml:masterConfirmation/fpml:masterConfirmationType = 'Variance Swap (Europe)'">Variance Swap (Europe)</xsl:when>
<xsl:when test="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:documentation/fpml:masterConfirmation/fpml:masterConfirmationType = '2005VarianceSwapEuropeanInterdealer'">Variance Swap (Europe)</xsl:when>
<xsl:when test="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:documentation/fpml:masterConfirmation/fpml:masterConfirmationType = 'ISDA2007VarianceSwapEuropean'">Variance Swap (Europe)</xsl:when>

<xsl:when test="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:documentation/fpml:masterConfirmation/fpml:masterConfirmationType = 'Variance Swap (Japan)'">Variance Swap (Japan)</xsl:when>
<xsl:when test="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:documentation/fpml:masterConfirmation/fpml:masterConfirmationType = 'ISDA2006VarianceSwapJapaneseInterdealer'">Variance Swap (Japan)</xsl:when>

</xsl:choose>
</xsl:variable>

<xsl:template match="fpml:SWDML">
<xsl:variable name="newContext">In <xsl:value-of select="local-name()"/></xsl:variable>

<results version="1.0">


<xsl:if test="not($version='4-2')">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Invalid version attribute. Value = '<xsl:value-of select="$version"/>'.</text></error>
</xsl:if>


<xsl:if test="not(fpml:swShortFormTrade or fpml:swLongFormTrade)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing swShortFormTrade or swLongFormTrade element. Required in this context.</text></error>
</xsl:if>

<xsl:if test="fpml:swShortFormTrade">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Short Form trades are not currently supported for equity derivative products.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:swLongFormTrade">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

</results>
</xsl:template>


<xsl:template match="fpml:swLongFormTrade">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="not(fpml:swOriginatorPartyReference)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing swOriginatorPartyReference.</text></error>
</xsl:if>


<xsl:variable name="href"><xsl:value-of select="fpml:swOriginatorPartyReference/@href"/></xsl:variable>
<xsl:if test="not(//fpml:FpML/fpml:party[@id = $href])">
<error><context><xsl:value-of select="$newContext"/></context><text>*** swOriginatorPartyReference/@href does not reference a valid //FpML/trade/party/@id. Value = '<xsl:value-of select="$href"/>'.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:swGiveUp">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>


<xsl:if test="fpml:novation">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected novation element in this context. The submission of novations via the delaer API is not currently supported for equity products.</text></error>
</xsl:if>


<xsl:if test="fpml:swAllocations">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected swAllocations element in this context. The submission of allocations via the delaer API is not currently supported for equity products.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:swStructuredTradeDetails">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

</xsl:template>


<xsl:template match="swGiveUp">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:variable name="hrefC"><xsl:value-of select="swCustomerTransaction/swCustomer/@href"/></xsl:variable>
<xsl:variable name="hrefD"><xsl:value-of select="swInterDealerTransaction/swExecutingDealer/@href"/></xsl:variable>
<xsl:variable name="hrefCPB"><xsl:value-of select="swCustomerTransaction/swPrimeBroker/@href"/></xsl:variable>
<xsl:variable name="hrefDPB"><xsl:value-of select="swInterDealerTransaction/swPrimeBroker/@href"/></xsl:variable>


<xsl:if test="$hrefC=$hrefD">
<error><context><xsl:value-of select="$newContext"/></context><text>*** swCustomerTransaction/swCustomer/@href and swInterDealerTransaction/swExecutingDealer/@href values must not be the same.</text></error>
</xsl:if>


<xsl:if test="$hrefC=$hrefCPB">
<error><context><xsl:value-of select="$newContext"/></context><text>*** swCustomerTransaction/swCustomer/@href and swCustomerTransaction/swPrimeBroker/@href values must not be the same.</text></error>
</xsl:if>


<xsl:if test="$hrefD=$hrefCPB">
<error><context><xsl:value-of select="$newContext"/></context><text>*** swInterDealerTransaction/swExecutingDealer/@href and swCustomerTransaction/swPrimeBroker/@href values must not be the same.</text></error>
</xsl:if>


<xsl:if test="$hrefD=$hrefDPB">
<error><context><xsl:value-of select="$newContext"/></context><text>*** swInterDealerTransaction/swExecutingDealer/@href and swInterDealerTransaction/swPrimeBroker/@href values must not be the same.</text></error>
</xsl:if>


<xsl:if test="$hrefC=$hrefDPB">
<error><context><xsl:value-of select="$newContext"/></context><text>*** swCustomerTransaction/swCustomer/@href and swInterDealerTransaction/swPrimeBroker/@href values must not be the same.</text></error>
</xsl:if>


<xsl:if test="not(//fpml:FpML/fpml:trade/fpml:party[@id=$hrefC])">
<error><context><xsl:value-of select="$newContext"/></context><text>*** swCustomerTransaction/swCustomer/@href does not reference a valid //FpML/trade/party/@id. Value = '<xsl:value-of select="$hrefC"/>'.</text></error>
</xsl:if>


<xsl:if test="not(//fpml:FpML/fpml:trade/fpml:party[@id=$href])">
<error><context><xsl:value-of select="$newContext"/></context><text>*** swCustomerTransaction/swPrimeBroker/@href does not reference a valid //FpML//party/@id. Value = '<xsl:value-of select="$hrefCPB"/>'.</text></error>
</xsl:if>


<xsl:if test="not(//fpml:FpML/fpml:trade/fpml:party[@id=$hrefD])">
<error><context><xsl:value-of select="$newContext"/></context><text>*** swInterDealerTransaction/swExecutingDealer/@href does not reference a valid //FpML/trade/party/@id. Value = '<xsl:value-of select="$hrefD"/>'.</text></error>
</xsl:if>


<xsl:if test="not(//fpml:FpML/fpml:trade/fpml:party[@id=$hrefDPB])">
<error><context><xsl:value-of select="$newContext"/></context><text>*** swInterDealerTransaction/swPrimeBroker/@href does not reference a valid //FpML/trade/party/@id. Value = '<xsl:value-of select="$hrefDPB"/>'.</text></error>
</xsl:if>


<xsl:if test="$hrefDPB=$hrefCPB">
<xsl:if test="count(//fpml:FpML/fpml:trade/fpml:party) != 3">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected number of party child elements encountered. 3 expected.</text></error>
</xsl:if>
</xsl:if>


<xsl:if test="$hrefDPB!=$hrefCPB">
<xsl:if test="count(//FpML/trade/party) != 4">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected number of party child elements encountered. 4 expected.</text></error>
</xsl:if>
</xsl:if>



<xsl:if test="$productType = 'Equity Share Option' or $productType = 'Equity Index Option' or $productType='Share Varince Swap' or $productType = 'Index Variance Swap'">
<xsl:if test="($hrefD != //fpml:FpML/fpml:trade/fpml:buyerPartyReference/@href) and ($hrefD != //fpml:FpML/fpml:trade/fpml:payerPartyReference/@href)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** swInterDealerTransaction/swExecutingDealer/@href must be a buyer or seller if product type is 'Equity Share Option', 'Equity Index Option', 'Share Variance Swap' or 'Index Variance Swap'.</text></error>
</xsl:if>
<xsl:if test="($hrefC != //fpml:FpML/fpml:trade/fpml:buyerPartyReference/@href) and ($hrefC != //fpml:FpML/fpml:trade/fpml:buyerPartyReference/@href)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** a payer or receiver on swap if product type is 'Equity Share Option', 'Equity Index Option', 'Share Variance Swap' or 'Index Variance Swap'.</text></error>
</xsl:if>
</xsl:if>

</xsl:template>



<xsl:template match="fpml:swStructuredTradeDetails">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:call-template name="isValidProductType">
<xsl:with-param name="elementName">swProductType</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:swProductType"/></xsl:with-param>
<xsl:with-param name="testNumber"></xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>

<xsl:apply-templates select="fpml:FpML">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

<xsl:apply-templates select="fpml:swExtendedTradeDetails">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

</xsl:template>


<xsl:template match="fpml:FpML">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="not($FpMLVersion='4-2')">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Invalid version attribute. Value = '<xsl:value-of select="$FpMLVersion"/>'.</text></error>
</xsl:if>


<xsl:if test="fpml:validation">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected validation element encountered in this context.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:trade">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>


<xsl:if test="not(fpml:trade)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing trade element.</text></error>
</xsl:if>


<xsl:if test="fpml:portfolio">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected portfolio element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="count(fpml:party)&lt; 2">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected number of party child elements encountered. At least 2 expected.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:party">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

</xsl:template>


<xsl:template match="fpml:trade">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>

<xsl:apply-templates select="fpml:tradeHeader">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>


<xsl:if test="$productType='Equity Share Option' or $productType='Equity Index Option'">
<xsl:if test="not(fpml:equityOptionTransactionSupplement)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing equityOptionTransactionSupplement element. Element must be present if product type is 'Equity Share Option' or 'Equity Index Option'.</text></error>
</xsl:if>
</xsl:if>


<xsl:if test="$productType='Share Variance Swap' or $productType='Index Variance Swap'">
<xsl:if test="not(fpml:equitySwapTransactionSupplement)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing equitySwapTransactionSupplement element. Element must be present if product type is 'Share Variance Swap' or 'Index Variance Swap'.</text></error>
</xsl:if>
</xsl:if>

<xsl:apply-templates select="fpml:equityOptionTransactionSupplement|fpml:equitySwapTransactionSupplement">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>


<xsl:if test="fpml:calculationAgent">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected calculationAgent element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:calculationAgentBusinessCenter">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected calculationAgentBusinessCenter element encountered in this context.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:collateral">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>


<xsl:if test="not(fpml:documentation)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing documentation element.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:documentation">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>


<xsl:if test="fpml:governingLaw">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected governingLaw element encountered in this context.</text></error>
</xsl:if>

</xsl:template>


<xsl:template match="fpml:collateral">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>

<xsl:apply-templates select="fpml:independentAmount">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

</xsl:template>


<xsl:template match="fpml:independentAmount">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:variable name="payer"><xsl:value-of select="fpml:payerPartyReference/@href"/></xsl:variable>
<xsl:choose>
<xsl:when test="$payer='partyA'"/>
<xsl:when test="$payer='partyB'"/>
<xsl:otherwise><error><context><xsl:value-of select="$newContext"/></context><text>*** Missing or invalid payerPartyReference/@href value. Value = '<xsl:value-of select="$payer"/>'.</text></error></xsl:otherwise>
</xsl:choose>


<xsl:variable name="receiver"><xsl:value-of select="fpml:receiverPartyReference/@href"/></xsl:variable>
<xsl:choose>
<xsl:when test="$receiver='partyA'"/>
<xsl:when test="$receiver='partyB'"/>
<xsl:otherwise><error><context><xsl:value-of select="$newContext"/></context><text>*** Missing or invalid receiverPartyReference/@href value. Value = '<xsl:value-of select="$receiver"/>'.</text></error></xsl:otherwise>
</xsl:choose>


<xsl:if test="$payer=$receiver"><error><context><xsl:value-of select="$newContext"/></context><text>*** payerPartyReference/@href and receiverPartyReference/@href values are the same.</text></error></xsl:if>

<xsl:apply-templates select="fpml:paymentDetail">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

</xsl:template>


<xsl:template match="fpml:paymentDetail">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="fpml:adjustablePaymentDate">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected adjustablePaymentDate element in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:adjustedPaymentDate">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected adjustedPaymentDate element in this context.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:paymentAmount">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>


<xsl:if test="fpml:paymentRule">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected paymentRule element in this context.</text></error>
</xsl:if>

</xsl:template>


<xsl:template match="fpml:documentation">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="fpml:masterAgreement">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected masterAgreement element in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:brokerConfirmation">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected brokerConfirmation element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:contractualDefinitions">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected contractualDefinitions element in this context.</text></error>
</xsl:if>


<xsl:if test="not(fpml:masterConfirmation)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing masterConfirmation element  in this context.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:masterConfirmation">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>


<xsl:if test="fpml:contractualSupplement">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected contractualSupplement element in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:contractualMatrix">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected contractualMatrix element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:creditSupportDocument">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected creditSupportDocument element encountered in this context.</text></error>
</xsl:if>

</xsl:template>


<xsl:template match="fpml:masterConfirmation">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="$productType = 'Equity Share Option' or $productType = 'Equity Index Option'">
<xsl:call-template name="isValidEquityConfirmationType">
<xsl:with-param name="elementName">masterConfirmationType</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:masterConfirmationType"/></xsl:with-param>
<xsl:with-param name="testNumber"></xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>


<xsl:if test="$productType = 'Share Variance Swap' or $productType = 'Index Variance Swap'">
<xsl:call-template name="isValidVarianceSwapConfirmationType">
<xsl:with-param name="elementName">masterConfirmationType</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:masterConfirmationType"/></xsl:with-param>
<xsl:with-param name="testNumber"></xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>

</xsl:template>


<xsl:template match="fpml:swExtendedTradeDetails">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>

<xsl:apply-templates select="fpml:swTradeHeader">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>


<xsl:if test="test=fpml:swExitReason">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected swExitReason element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="not(fpml:swVarianceSwapDetails) and ($productType='Share Variance Swap' or $productType='Index Variance Swap')">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing swVarianceSwapDetails element encountered in this context. Element must be present if product type is 'Share Variance Swap' or 'Index Variance Swap'.</text></error>
</xsl:if>


<xsl:if test="fpml:swVarianceSwapDetails and $productType!='Share Variance Swap' and $productType != 'Index Variance Swap'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected swVarianceSwapDetails element encountered in this context. Element must be not present if product type is not 'Share Variance Swap' or 'Index Variance Swap'.</text></error>
</xsl:if>


<xsl:if test="not(fpml:swEquityOptionDetails) and $productType='Equity Share Option'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing swEquityOptionDetails element encountered in this context. Element must be present if product type is 'Equity Share Option' or 'Equity Index Option'.</text></error>
</xsl:if>


<xsl:if test="fpml:swEquityOptionDetails and $productType!='Equity Share Option' and $productType != 'Equity Index Option'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected swEquityOptionDetails element encountered in this context. Element must be not present if product type is not 'Equity Share Option' or 'Equity Index Option'.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:swVarianceSwapDetails">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

<xsl:apply-templates select="fpml:swEquityOptionDetails">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

</xsl:template>


<xsl:template match="fpml:swTradeHeader">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>



<xsl:call-template name="isValidBoolean">
<xsl:with-param name="elementName">swManualConfirmationRequired</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:swManualConfirmationRequired"/></xsl:with-param>
<xsl:with-param name="testNumber"></xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>

</xsl:template>


<xsl:template match="fpml:swVarianceSwapDetails">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:call-template name="isValidNumber">
<xsl:with-param name="elementName">volatilityStrikePrice</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:volatilityStrikePrice"/></xsl:with-param>
<xsl:with-param name="minIncl">0.01</xsl:with-param>
<xsl:with-param name="maxIncl">100.00</xsl:with-param>
<xsl:with-param name="maxDecs">2</xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>


<xsl:if test="fpml:swTotalVarianceCap and not (//fpml:FpML/fpml:trade/fpml:equitySwapTransactionSupplement/fpml:varianceLeg/fpml:equityAmount/fpml:variance/fpml:varianceCap='true')">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected swTotalVarianceCap element encountered in this context. Element must be not present unless variance/varianceCap is equal to 'true'.</text></error>
</xsl:if>


<xsl:if test="//fpml:FpML/fpml:trade/fpml:equitySwapTransactionSupplement/fpml:varianceLeg/fpml:equityAmount/fpml:variance/fpml:varianceCap='true'">
<xsl:call-template name="isValidNumber">
<xsl:with-param name="elementName">swTotalVarianceCap</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:swTotalVarianceCap"/></xsl:with-param>
<xsl:with-param name="minIncl">0.0000</xsl:with-param>
<xsl:with-param name="maxIncl">998010.0000</xsl:with-param>
<xsl:with-param name="maxDecs">4</xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>


<xsl:if test="fpml:swTotalVolatilityCap and not (//fpml:FpML/fpml:trade/fpml:equitySwapTransactionSupplement/fpml:varianceLeg/fpml:equityAmount/fpml:variance/fpml:varianceCap='true')">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected swTotalVolatilityCap element encountered in this context. Element must be not present unless variance/varianceCap is equal to 'true'.</text></error>
</xsl:if>


<xsl:if test="//fpml:FpML/fpml:trade/fpml:equitySwapTransactionSupplement/fpml:varianceLeg/fpml:equityAmount/fpml:variance/fpml:varianceCap='true'">
<xsl:call-template name="isValidNumber">
<xsl:with-param name="elementName">swTotalVolatilityCap</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:swTotalVolatilityCap"/></xsl:with-param>
<xsl:with-param name="minIncl">0.0001</xsl:with-param>
<xsl:with-param name="maxIncl">999.9999</xsl:with-param>
<xsl:with-param name="maxDecs">4</xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>


<xsl:call-template name="isValidBoolean">
<xsl:with-param name="elementName">swExpectedNOverride</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:swExpectedNOverride"/></xsl:with-param>
<xsl:with-param name="testNumber"></xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>


<xsl:if test="fpml:swSettlementCurrencyVegaNotionalAmount and not (/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equitySwapTransactionSupplement/fpml:varianceLeg/fpml:equityAmount/fpml:variance/fpml:fxFeature)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected swSettlementCurrencyVegaNotionalAmount encountered in this context when no fxFeature is present. A settlement currency vega notional is only allowed for trades settling cross currency.</text></error>
</xsl:if>


<xsl:choose>
<xsl:when test="not (fpml:swSettlementCurrencyVegaNotionalAmount) and  /fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equitySwapTransactionSupplement/fpml:varianceLeg/fpml:equityAmount/fpml:variance/fpml:fxFeature">
<xsl:if test="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equitySwapTransactionSupplement/fpml:varianceLeg/fpml:equityAmount/fpml:variance/fpml:fxFeature/fpml:referenceCurrency='AUD'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing swSettlementCurrencyVegaNotionalAmount in this context when currency is AUD. If a normally deliverable currency is traded as non deliverable, swSettlementCurrencyVegaNotionalAmount is required.</text></error>
</xsl:if>
<xsl:if test="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equitySwapTransactionSupplement/fpml:varianceLeg/fpml:equityAmount/fpml:variance/fpml:fxFeature/fpml:referenceCurrency='HKD'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing swSettlementCurrencyVegaNotionalAmount in this context when currency is HKD. If a normally deliverable currency is traded as non deliverable, swSettlementCurrencyVegaNotionalAmount is required.</text></error>
</xsl:if>
<xsl:if test="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equitySwapTransactionSupplement/fpml:varianceLeg/fpml:equityAmount/fpml:variance/fpml:fxFeature/fpml:referenceCurrency='NZD'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing swSettlementCurrencyVegaNotionalAmount in this context when currency is NZD. If a normally deliverable currency is traded as non deliverable, swSettlementCurrencyVegaNotionalAmount is required.</text></error>
</xsl:if>
<xsl:if test="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equitySwapTransactionSupplement/fpml:varianceLeg/fpml:equityAmount/fpml:variance/fpml:fxFeature/fpml:referenceCurrency='SGD'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing swSettlementCurrencyVegaNotionalAmount in this context when currency is SGD. If a normally deliverable currency is traded as non deliverable, swSettlementCurrencyVegaNotionalAmount is required.</text></error>
</xsl:if>
</xsl:when>
</xsl:choose>


<xsl:if test="fpml:swSettlementCurrencyVegaNotionalAmount">
<xsl:call-template name="isValidNumber">
<xsl:with-param name="elementName">swSettlementCurrencyVegaNotionalAmount</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:swSettlementCurrencyVegaNotionalAmount"/></xsl:with-param>
<xsl:with-param name="minIncl">0.01</xsl:with-param>
<xsl:with-param name="maxIncl">9999999999.99</xsl:with-param>
<xsl:with-param name="maxDecs">2</xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>


<xsl:if test="fpml:swVegaFxSpotRate and not (/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equitySwapTransactionSupplement/fpml:varianceLeg/fpml:equityAmount/fpml:variance/fpml:fxFeature)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected swVegaFxSpotRate encountered in this context when no fxFeature is present. A vega spot rate is only allowed for trades settling cross currency.</text></error>
</xsl:if>


<xsl:choose>
<xsl:when test="not (fpml:swVegaFxSpotRate) and /fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equitySwapTransactionSupplement/fpml:varianceLeg/fpml:equityAmount/fpml:variance/fpml:fxFeature">
<xsl:if test="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equitySwapTransactionSupplement/fpml:varianceLeg/fpml:equityAmount/fpml:variance/fpml:fxFeature/fpml:referenceCurrency='AUD'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing swVegaFxSpotRate in this context when currency is AUD. If a normally deliverable currency is traded as non deliverable, swVegaFxSpotRate is required.</text></error>
</xsl:if>
<xsl:if test="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equitySwapTransactionSupplement/fpml:varianceLeg/fpml:equityAmount/fpml:variance/fpml:fxFeature/fpml:referenceCurrency='HKD'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing swVegaFxSpotRate in this context when currency is HKD. If a normally deliverable currency is traded as non deliverable, swVegaFxSpotRate is required.</text></error>
</xsl:if>
<xsl:if test="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equitySwapTransactionSupplement/fpml:varianceLeg/fpml:equityAmount/fpml:variance/fpml:fxFeature/fpml:referenceCurrency='NZD'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing swVegaFxSpotRate in this context when currency is NZD. If a normally deliverable currency is traded as non deliverable, swVegaFxSpotRate is required.</text></error>
</xsl:if>
<xsl:if test="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equitySwapTransactionSupplement/fpml:varianceLeg/fpml:equityAmount/fpml:variance/fpml:fxFeature/fpml:referenceCurrency='SGD'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing swVegaFxSpotRate in this context when currency is SGD. If a normally deliverable currency is traded as non deliverable, swVegaFxSpotRate is required.</text></error>
</xsl:if>
</xsl:when>
</xsl:choose>


<xsl:if test="fpml:swVegaFxSpotRate">
<xsl:call-template name="isValidNumber">
<xsl:with-param name="elementName">swVegaFxSpotRate</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:swVegaFxSpotRate"/></xsl:with-param>
<xsl:with-param name="minIncl">0.000001</xsl:with-param>
<xsl:with-param name="maxIncl">9999.999999</xsl:with-param>
<xsl:with-param name="maxDecs">6</xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>


<xsl:if  test="fpml:swVarianceSwapHolidayDate and fpml:swExpectedNOverride ='true'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** No swVarianceSwapHolidayDate elements may be submitted if swExpectedNOverride is set to 'true'.</text></error>
</xsl:if>


<xsl:if test="fpml:swVarianceSwapHolidayDate">
<xsl:for-each select="swVarianceSwapHolidayDate">
<xsl:call-template name="isValidDate">
<xsl:with-param name="elementName">swVarianceSwapHolidayDate</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:swVarianceSwapHolidayDate"/></xsl:with-param>
<xsl:with-param name="testNumber"></xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:for-each>
</xsl:if>


<xsl:if  test="fpml:swVarianceSwapTermination">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected swVarianceSwapTermination element encountered in this context.</text></error>
</xsl:if>

</xsl:template>


<xsl:template match="fpml:swEquityOptionDetails">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="fpml:numberOfShares and $productType != 'Equity Share Option'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected numberOfShares element encountered in this context when product type is not 'Equity Share Option'. Element only applies for Equity Share Options.</text></error>
</xsl:if>


<xsl:if test="not(fpml:numberOfShares) and $productType = 'Equity Share Option'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing numberOfShares element in this context when product type is 'Equity Share Option'. Element required for Equity Share Options.</text></error>
</xsl:if>



<xsl:choose>
<xsl:when test="fpml:swDeltaCross and ($productType='Share Variance Swap' or $productType='Index Variance Swap')">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected swDeltaCross element encountered in this context. Element must not be present if product type is 'Share Variance Swap' or 'Index Variance Swap'.</text></error>
</xsl:when>
<xsl:when test="fpml:swDeltaCross and $productType='Equity Index Option' and $docsType='Equity Options (Americas)'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected swDeltaCross element encountered in this context. Element must not be present if product is an 'Equity Index Option' for a US underlyer.</text></error>
</xsl:when>
</xsl:choose>

<xsl:apply-templates select="fpml:swDeltaCross">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

<xsl:if test="fpml:swDefaultSettlementMethod">
<xsl:call-template name="isValidDefaultSettlementMethod">
<xsl:with-param name="elementName">swDefaultSettlementMethod</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:swDefaultSettlementMethod"/></xsl:with-param>
<xsl:with-param name="testNumber"></xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>

</xsl:template>


<xsl:template match="fpml:swDeltaCross">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:choose>
<xsl:when test="fpml:buyerPartyReference/@href=/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equityOptionTransactionSupplement/fpml:buyerPartyReference/@href"/>
<xsl:when test="fpml:buyerPartyReference/@href=/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equityOptionTransactionSupplement/fpml:sellerPartyReference/@href"/>
<xsl:otherwise>
<error><context><xsl:value-of select="$newContext"/></context><text>*** Invalid buyerPartyReference/@href attribute value. Value = '<xsl:value-of select='fpml:buyerPartyReference/@href'/>'.</text></error>
</xsl:otherwise>
</xsl:choose>


<xsl:choose>
<xsl:when test="fpml:sellerPartyReference/@href=/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equityOptionTransactionSupplement/fpml:buyerPartyReference/@href"/>
<xsl:when test="fpml:sellerPartyReference/@href=/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equityOptionTransactionSupplement/fpml:sellerPartyReference/@href"/>
<xsl:otherwise>
<error><context><xsl:value-of select="$newContext"/></context><text>*** Invalid sellerPartyReference/@href attribute value. Value = '<xsl:value-of select='fpml:sellerPartyReference/@href'/>'.</text></error>
</xsl:otherwise>
</xsl:choose>


<xsl:if test="fpml:buyerPartyReference/@href = fpml:sellerPartyReference/@href">
<error><context><xsl:value-of select="$newContext"/></context><text>*** buyerPartyReference/@href and sellerPartyReference/@href values are the same.</text></error>
</xsl:if>


<xsl:if test="not(fpml:equity) and $productType = 'Equity Share Option'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing equity element when product type is 'Equity Share Option'.</text></error>
</xsl:if>


<xsl:if test="$productType = 'Equity Share Option'">
<xsl:if test="not(fpml:equity/fpml:instrumentId = //fpml:FpML/fpml:trade/fpml:equityOptionTransactionSupplement/fpml:underlyer/fpml:singleUnderlyer/fpml:equity/fpml:instrumentId)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** The equity/instrumentId must equal the //FpML/trade/equityOptionTransactionSupplement/underlyer/singleUnderlyer/equity/instrumentId.</text></error>
</xsl:if>
</xsl:if>

<xsl:apply-templates select="fpml:equity|fpml:future">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

<xsl:apply-templates select="fpml:swPrice">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>


<xsl:call-template name="isValidNumber">
<xsl:with-param name="elementName">swQuantity</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:swQuantity"/></xsl:with-param>
<xsl:with-param name="minIncl">1</xsl:with-param>
<xsl:with-param name="maxIncl">999999999</xsl:with-param>
<xsl:with-param name="maxDecs">0</xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>


<xsl:if test="fpml:swDelta">
<xsl:call-template name="isValidNumber">
<xsl:with-param name="elementName">swDelta</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:swDelta"/></xsl:with-param>
<xsl:with-param name="minIncl">0</xsl:with-param>
<xsl:with-param name="maxIncl">9.9999999</xsl:with-param>
<xsl:with-param name="maxDecs">7</xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>


<xsl:if test="fpml:swOffshoreCross and not($docsType='Equity Options (AEJ)' and $productType = 'Equity Share Option')">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected swOffshoreCross in this context. This element may only be used with AEJ Share Options.</text></error>
</xsl:if>


<xsl:if test="fpml:swOffshoreCross and  $docsType='Equity Options (AEJ)'">
<xsl:call-template name="isValidBusinessCenter">
<xsl:with-param name="elementName">swOffshoreCrossLocation</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:swOffshoreCross/fpml:swOffshoreCrossLocation"/></xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>


<xsl:if test="fpml:swCrossExchangeId and not($productType='Equity Share Option' and $docsType='Equity Options (Americas)' and //fpml:FpML/fpml:trade/fpml:equityOptionTransactionSupplement/fpml:equityPremium/fpml:paymentAmount/fpml:currency='USD')">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected swCrossExchangeId in this context. This element may only be used for product type 'Equity Share Option', Docs Type 'Equity Options (Americas)' and currency 'USD' </text></error>
</xsl:if>

</xsl:template>


<xsl:template match="fpml:swPrice">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="not(fpml:currency = //fpml:FpML/fpml:trade/fpml:equityOptionTransactionSupplement/fpml:equityPremium/fpml:paymentAmount/fpml:currency) and not( /fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equityOptionTransactionSupplement/fpml:fxFeature)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** The currency must equal equityPremium/paymentAmount/currency when option is Vanilla settled.</text></error>
</xsl:if>


<xsl:if test="not(fpml:currency = //fpml:FpML/fpml:trade/fpml:equityOptionTransactionSupplement/fpml:fxFeature/fpml:referenceCurrency) and /fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equityOptionTransactionSupplement/fpml:fxFeature">
<error><context><xsl:value-of select="$newContext"/></context><text>*** The currency must equal fxFeature/referenceCurrency when option is not Vanilla settled.</text></error>
</xsl:if>



<xsl:if test="$productType = 'Equity Share Option'">
<xsl:choose>
<xsl:when test="$docsType='Equity Options (Europe)' or $docsType='Equity Options (Americas)'">
<xsl:call-template name="isValidNumber">
<xsl:with-param name="elementName">amount</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:amount"/></xsl:with-param>
<xsl:with-param name="minIncl">0.00001</xsl:with-param>
<xsl:with-param name="maxIncl">9999.99999</xsl:with-param>
<xsl:with-param name="maxDecs">5</xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:when>
<xsl:when test="$docsType='Equity Options (Japan)' or $docsType='Equity Options (AEJ)'">
<xsl:call-template name="isValidNumber">
<xsl:with-param name="elementName">amount</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:amount"/></xsl:with-param>
<xsl:with-param name="minIncl">0.00001</xsl:with-param>
<xsl:with-param name="maxIncl">999999999.99999</xsl:with-param>
<xsl:with-param name="maxDecs">5</xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:when>
<xsl:otherwise><error><context><xsl:value-of select="$newContext"/></context><text>*** Empty or invalid masterConfirmationType element. Value = '<xsl:value-of select="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:documentation/fpml:masterConfirmation/fpml:masterConfirmationType"/>'.</text></error></xsl:otherwise>
</xsl:choose>
</xsl:if>


<xsl:if test="$productType='Equity Index Option'">
<xsl:call-template name="isValidNumber">
<xsl:with-param name="elementName">amount</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:amount"/></xsl:with-param>
<xsl:with-param name="minIncl">0.00001</xsl:with-param>
<xsl:with-param name="maxIncl">999999999.99999</xsl:with-param>
<xsl:with-param name="maxDecs">5</xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>

</xsl:template>


<xsl:template match="fpml:tradeHeader">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="count(fpml:partyTradeIdentifier) != 2"><error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected number of partyTradeIdentifier child elements encountered. Exactly 2 expected.</text></error></xsl:if>

<xsl:apply-templates select="fpml:partyTradeIdentifier">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

<xsl:apply-templates select="fpml:partyTradeInformation">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

</xsl:template>


<xsl:template match="fpml:partyTradeIdentifier">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/>[<xsl:number value="position()"/>]</xsl:variable>


<xsl:if test="$productType = 'Equity Share Option' or $productType = 'Equity Index Option'">
<xsl:choose>
<xsl:when test="fpml:partyReference/@href=/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equityOptionTransactionSupplement/fpml:buyerPartyReference/@href"/>
<xsl:when test="fpml:partyReference/@href=/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equityOptionTransactionSupplement/fpml:sellerPartyReference/@href"/>
<xsl:otherwise>
<error><context><xsl:value-of select="$newContext"/></context><text>*** Invalid partyReference/@href attribute value. Value = '<xsl:value-of select='fpml:partyReference/@href'/>'.</text></error>
</xsl:otherwise>
</xsl:choose>
</xsl:if>


<xsl:if test="$productType = 'Share Variance Swap' or $productType = 'Index Variance Swap'">
<xsl:choose>
<xsl:when test="fpml:partyReference/@href=/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equitySwapTransactionSupplement/fpml:buyerPartyReference/@href"/>
<xsl:when test="fpml:partyReference/@href=/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equitySwapTransactionSupplement/fpml:sellerPartyReference/@href"/>
<xsl:otherwise>
<error><context><xsl:value-of select="$newContext"/></context><text>*** Invalid partyReference/@href attribute value. Value = '<xsl:value-of select='fpml:partyReference/@href'/>'.</text></error>
</xsl:otherwise>
</xsl:choose>
</xsl:if>


<xsl:variable name="tradeIdScheme"><xsl:value-of select="fpml:tradeId/@tradeIdScheme"/></xsl:variable>
<xsl:if test="$tradeIdScheme=''">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing or empty tradeId/@tradeIdScheme attribute.</text></error>
</xsl:if>


<xsl:variable name="tradeId"><xsl:value-of select="fpml:tradeId"/></xsl:variable>
<xsl:if test="$tradeId=''"><error><context><xsl:value-of select="$newContext"/></context><text>*** Empty tradeId element.</text></error></xsl:if>


<xsl:if test="fpml:linkId">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected linkId element encountered in this context.</text></error>
</xsl:if>

</xsl:template>


<xsl:template match="fpml:partyTradeInformation">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/>[<xsl:number value="position()"/>]</xsl:variable>


<xsl:if test="$productType = 'Equity Share Option' or $productType = 'Equity Index Option'">
<xsl:choose>
<xsl:when test="fpml:partyReference/@href=/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equityOptionTransactionSupplement/fpml:buyerPartyReference/@href"/>
<xsl:when test="fpml:partyReference/@href=/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equityOptionTransactionSupplement/fpml:sellerPartyReference/@href"/>
<xsl:otherwise>
<error><context><xsl:value-of select="$newContext"/></context><text>*** Invalid partyReference/@href attribute value. Value = '<xsl:value-of select='fpml:partyReference/@href'/>'.</text></error>
</xsl:otherwise>
</xsl:choose>
</xsl:if>


<xsl:if test="$productType = 'Share Variance Swap' or $productType = 'Index Variance Swap'">
<xsl:choose>
<xsl:when test="fpml:partyReference/@href=/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equitySwapTransactionSupplement/fpml:buyerPartyReference/@href"/>
<xsl:when test="fpml:partyReference/@href=/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equitySwapTransactionSupplement/fpml:sellerPartyReference/@href"/>
<xsl:otherwise>
<error><context><xsl:value-of select="$newContext"/></context><text>*** Invalid partyReference/@href attribute value. Value = '<xsl:value-of select='fpml:partyReference/@href'/>'.</text></error>
</xsl:otherwise>
</xsl:choose>
</xsl:if>


<xsl:if test="fpml:trader">
<xsl:if test="fpml:trader=''">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Empty trader element.</text></error>
</xsl:if>
</xsl:if>

</xsl:template>


<xsl:template match="fpml:adjustableDate">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>

<xsl:apply-templates select="fpml:dateAdjustments">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

</xsl:template>


<xsl:template match="fpml:party">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/>[<xsl:number value="position()"/>]</xsl:variable>


<xsl:if test="not(fpml:partyId)"><error><context><xsl:value-of select="$newContext"/></context><text>*** Missing partyId element.</text></error></xsl:if>


<xsl:variable name="partyName"><xsl:value-of select="fpml:partyName"/></xsl:variable>
<xsl:if test="fpml:partyName">
<xsl:if test="$partyName=''"><error><context><xsl:value-of select="$newContext"/></context><text>*** Empty partyName element.</text></error></xsl:if>
</xsl:if>


<xsl:if test="string-length($partyName) &gt; 200"><error><context><xsl:value-of select="$newContext"/></context><text>*** Invalid partyName string length. Exceeded max length of 200 characters.</text></error></xsl:if>

</xsl:template>


<xsl:template match="fpml:otherPartyPayment">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/>[<xsl:number value="position()"/>]</xsl:variable>


<xsl:if test="$productType='Equity Share Option' or $productType='Equity Index Option'">
<xsl:choose>
<xsl:when test="fpml:payerPartyReference/@href=/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equityOptionTransactionSupplement/fpml:buyerPartyReference/@href"/>
<xsl:when test="fpml:payerPartyReference/@href=/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equityOptionTransactionSupplement/fpml:sellerPartyReference/@href"/>
<xsl:otherwise>
<error><context><xsl:value-of select="$newContext"/></context><text>*** Invalid payerPartyReference/@href attribute value. Value = '<xsl:value-of select='fpml:payerPartyReference/@href'/>'.</text></error>
</xsl:otherwise>
</xsl:choose>
</xsl:if>


<xsl:if test="$productType='Equity Share Option' or $productType='Equity Index Option'">
<xsl:choose>
<xsl:when test="fpml:receiverPartyReference/@href=/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equityOptionTransactionSupplement/fpml:buyerPartyReference/@href">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Invalid receiverPartyReference/@href attribute value. Value = '<xsl:value-of select='fpml:receiverPartyReference/@href'/>'.</text></error>
</xsl:when>
<xsl:when test="fpml:receiverPartyReference/@href=/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equityOptionTransactionSupplement/fpml:sellerPartyReference/@href">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Invalid receiverPartyReference/@href attribute value. Value = '<xsl:value-of select='fpml:receiverPartyReference/@href'/>'.</text></error>
</xsl:when>
<xsl:otherwise/>
</xsl:choose>
</xsl:if>


<xsl:if test="$productType='Share Variance Swap' or $productType='Index Variance Swap'">
<xsl:choose>
<xsl:when test="fpml:payerPartyReference/@href=/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equitySwapTransactionSupplement/fpml:buyerPartyReference/@href"/>
<xsl:when test="fpml:payerPartyReference/@href=/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equitySwapTransactionSupplement/fpml:sellerPartyReference/@href"/>
<xsl:otherwise>
<error><context><xsl:value-of select="$newContext"/></context><text>*** Invalid payerPartyReference/@href attribute value. Value = '<xsl:value-of select='fpml:payerPartyReference/@href'/>'.</text></error>
</xsl:otherwise>
</xsl:choose>
</xsl:if>


<xsl:if test="$productType='Share Variance Swap' or $productType='Index Variance Swap'">
<xsl:choose>
<xsl:when test="fpml:receiverPartyReference/@href=/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equitySwapTransactionSupplement/fpml:buyerPartyReference/@href">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Invalid receiverPartyReference/@href attribute value. Value = '<xsl:value-of select='fpml:receiverPartyReference/@href'/>'.</text></error>
</xsl:when>
<xsl:when test="fpml:receiverPartyReference/@href=/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equitySwapTransactionSupplement/fpml:sellerPartyReference/@href">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Invalid receiverPartyReference/@href attribute value. Value = '<xsl:value-of select='fpml:receiverPartyReference/@href'/>'.</text></error>
</xsl:when>
<xsl:otherwise/>
</xsl:choose>
</xsl:if>


<xsl:variable name="href1"><xsl:value-of select="fpml:payerPartyReference/@href"/></xsl:variable>
<xsl:variable name="href2"><xsl:value-of select="fpml:receiverPartyReference/@href"/></xsl:variable>
<xsl:if test="$href1=$href2"><error><context><xsl:value-of select="$newContext"/></context><text>*** payerPartyReference/@href and receiverPartyReference/@href values are the same.</text></error></xsl:if>


<xsl:if test="not(/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:party[@id=$href2])">
<error><context><xsl:value-of select="$newContext"/></context><text>*** The receiverPartyReference/@href value does not match an //FpML/party/@id value for any party. Value = '<xsl:value-of select="$href2"/>'.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:paymentAmount">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>


<xsl:if test="fpml:paymentDate">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected paymentDate element encountered in this context. Not expected for brokerage payment.</text></error>
</xsl:if>


<xsl:if test="fpml:adjustedPaymentDate">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected adjustedPaymentDate element encountered in this context. Not expected for brokerage payment.</text></error>
</xsl:if>


<xsl:if test="fpml:paymentType">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected paymentType element encountered in this context. Not expected for brokerage payment.</text></error>
</xsl:if>


<xsl:if test="fpml:settlementInformation">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected settlementInformation element encountered in this context. Not expected for brokerage payment.</text></error>
</xsl:if>

</xsl:template>


<xsl:template match="fpml:paymentAmount">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="ancestor::fpml:otherPartyPayment">
<xsl:call-template name="isValidNumber">
<xsl:with-param name="elementName">amount</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:amount"/></xsl:with-param>
<xsl:with-param name="minIncl">0.00</xsl:with-param>
<xsl:with-param name="maxIncl">999999999999.99</xsl:with-param>
<xsl:with-param name="maxDecs">2</xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>


<xsl:if test="ancestor::fpml:independentAmount">
<xsl:call-template name="isValidNumber">
<xsl:with-param name="elementName">paymentAmount/amount</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:amount"/></xsl:with-param>
<xsl:with-param name="minIncl">1.00</xsl:with-param>
<xsl:with-param name="maxIncl">999999999999.99</xsl:with-param>
<xsl:with-param name="maxDecs">2</xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>


<xsl:if test="($docsType='Equity Options (Europe)' or $docsType='Equity Options (AEJ)' or $docsType='Equity Options (Americas)') and ancestor::fpml:equityOptionTransactionSupplement">
<xsl:call-template name="isValidNumber">
<xsl:with-param name="elementName">amount</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:amount"/></xsl:with-param>
<xsl:with-param name="minIncl">0.00</xsl:with-param>
<xsl:with-param name="maxIncl">9999999999999.99</xsl:with-param>
<xsl:with-param name="maxDecs">2</xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>


<xsl:if test="$docsType='Equity Options (Japan)' and ancestor::fpml:equityOptionTransactionSupplement">
<xsl:call-template name="isValidIntegerNumber">
<xsl:with-param name="elementName">amount</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:amount"/></xsl:with-param>
<xsl:with-param name="minIncl">0</xsl:with-param>
<xsl:with-param name="maxIncl">901000000000000</xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>


<xsl:if test="ancestor::fpml:independentAmount">
<xsl:call-template name="isValidCurrency">
<xsl:with-param name="elementName">currency</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:currency"/></xsl:with-param>
<xsl:with-param name="testNumber"></xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>

</xsl:template>


<xsl:template match="fpml:instrumentId">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/>[<xsl:number value="position()"/>]</xsl:variable>


<xsl:call-template name="isValidInstrumentIdScheme">
<xsl:with-param name="elementName">instrumentId/@instrumentIdScheme</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="@instrumentIdScheme"/></xsl:with-param>
<xsl:with-param name="testNumber"></xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>

</xsl:template>


<xsl:template match="fpml:equityOptionTransactionSupplement">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:variable name="buyer"><xsl:value-of select="fpml:buyerPartyReference/@href"/></xsl:variable>
<xsl:if test="not(/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:party[@id=$buyer])">
<error><context><xsl:value-of select="$newContext"/></context><text>*** The buyerPartyReference/@href value does not match an //FpML/party/@id value for any party. Value = '<xsl:value-of select="$buyer"/>'.</text></error>
</xsl:if>


<xsl:variable name="seller"><xsl:value-of select="fpml:sellerPartyReference/@href"/></xsl:variable>
<xsl:if test="not(/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:party[@id=$seller])">
<error><context><xsl:value-of select="$newContext"/></context><text>*** The sellerPartyReference/@href value does not match an //FpML/party/@id value for any party. Value = '<xsl:value-of select="$seller"/>'.</text></error>
</xsl:if>


<xsl:if test="$buyer=$seller"><error><context><xsl:value-of select="$newContext"/></context><text>*** buyerPartyReference/@href and sellerPartyReference/@href values are the same.</text></error></xsl:if>


<xsl:if test="fpml:equityEffectiveDate">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected equityEffectiveDate element encountered in this context.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:underlyer">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>


<xsl:if test="fpml:notional">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected notional element encountered in this context.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:equityExercise">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>


<xsl:if test="fpml:fxFeature and not ($docsType='Equity Options (AEJ)' and fpml:equityExercise/fpml:settlementType = 'Cash')">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected fxFeature element encountered in this context. Element must not be present when Docs Type is not 'Equity Options (AEJ)' and equityExercise/settlementType is not 'Cash'.</text></error>
</xsl:if>


<xsl:if test="not(fpml:fxFeature) and $docsType='Equity Options (AEJ)' and fpml:equityExercise/fpml:settlementType = 'Cash'">
<xsl:choose>
<xsl:when test="fpml:equityExercise/fpml:settlementCurrency = 'AUD'"/>
<xsl:when test="fpml:equityExercise/fpml:settlementCurrency = 'HKD'"/>
<xsl:when test="fpml:equityExercise/fpml:settlementCurrency = 'NZD'"/>
<xsl:when test="fpml:equityExercise/fpml:settlementCurrency = 'SGD'"/>
<xsl:otherwise>
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing fxFeature element  when Docs Type is 'Equity Options (AEJ)' and equityExercise/settlementType is 'Cash' and equityExercise/settlementCurrency is a non-deliverable currency.</text></error>
</xsl:otherwise>
</xsl:choose>
</xsl:if>

<xsl:apply-templates select="fpml:fxFeature">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>


<xsl:if test="fpml:strategyFeature">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected strategyFeature element encountered in this context.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:strike">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>


<xsl:if test="fpml:spotPrice">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected spotPrice element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="$docsType='Equity Options (Europe)' or $docsType='Equity Options (AEJ)' or $docsType='Equity Options (Americas)'">
<xsl:call-template name="isValidNumber">
<xsl:with-param name="elementName">numberOfOptions</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:numberOfOptions"/></xsl:with-param>
<xsl:with-param name="minIncl">1</xsl:with-param>
<xsl:with-param name="maxIncl">999999999.99999</xsl:with-param>
<xsl:with-param name="maxDecs">5</xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>


<xsl:if test="$docsType='Equity Options (Japan)'">
<xsl:call-template name="isValidNumber">
<xsl:with-param name="elementName">numberOfOptions</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:numberOfOptions"/></xsl:with-param>
<xsl:with-param name="minIncl">1</xsl:with-param>
<xsl:with-param name="maxIncl">900999999.99</xsl:with-param>
<xsl:with-param name="maxDecs">2</xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>

<xsl:apply-templates select="fpml:equityPremium">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>


<xsl:if test="$productType='Equity Share Option' and $docsType='Equity Options (Europe)'">
<xsl:call-template name="isValidBoolean">
<xsl:with-param name="elementName">exchangeLookAlike</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:exchangeLookAlike"/></xsl:with-param>
<xsl:with-param name="testNumber"></xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>


<xsl:if test="$productType='Equity Share Option' and fpml:exchangeLookAlike and $docsType!='Equity Options (Europe)'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected exchangeLookAlike element encountered in this context when product type is 'Equity Share Option' and Docs Type is not 'Equity Options (Europe)'.</text></error>
</xsl:if>


<xsl:if test="$productType='Equity Index Option' and fpml:exchangeLookAlike">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected exchangeLookAlike element encountered in this context when product type is 'Equity Index Option'.</text></error>
</xsl:if>


<xsl:if test="fpml:exchangeTradedContractNearest and $docsType!='Equity Options (Europe)'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected exchangeTradedContractNearest element encountered in this context when productType is not 'Equity Index Option' and Docs Type is not 'Equity Options (Europe)'.</text></error>
</xsl:if>


<xsl:if test="fpml:exchangeTradedContractNearest">
<xsl:call-template name="isValidBoolean">
<xsl:with-param name="elementName">exchangeTradedContractNearest</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:exchangeTradedContractNearest"/></xsl:with-param>
<xsl:with-param name="testNumber"></xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>


<xsl:if test="fpml:multipleExchangeIndexAnnexFallback and ($productType='Equity Share Option' or $docsType='Equity Options (Japan)')">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected multipleExchangeIndexAnnexFallback element encountered in this contex when product type is 'Equity Share Option' or when Docs Type is 'Equity Options (Japan)'.</text></error>
</xsl:if>


<xsl:if test="fpml:multipleExchangeIndexAnnexFallback">
<xsl:call-template name="isValidBoolean">
<xsl:with-param name="elementName">multipleExchangeIndexAnnexFallback</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:multipleExchangeIndexAnnexFallback"/></xsl:with-param>
<xsl:with-param name="testNumber"></xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>


<xsl:if test="$productType = 'Equity Index Option' and fpml:methodOfAdjustment">
<error>
<context><xsl:value-of select="$newContext"/></context>
<text>*** Unexpected methodOfAdjustment element encountered in this context. Element must not be present when product type is 'Equity Index Option' or when product type is 'Equity Share Option' and Docs Type is 'Equity Options (Japan)' or 'Equity Options (AEJ)'.</text>
</error>
</xsl:if>


<xsl:if test="fpml:localJurisdiction">
<xsl:call-template name="isValidLocalJurisdiction">
<xsl:with-param name="elementName">localJurisdiction</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:localJurisdiction"/></xsl:with-param>
<xsl:with-param name="testNumber"></xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>


<xsl:if test="fpml:optionEntitlement and $productType='Equity Index Option'">
<error>
<context><xsl:value-of select="$newContext"/></context>
<text>*** Unexpected optionEntitlement element encountered in this context when product type is 'Equity Index Option'.</text>
</error>
</xsl:if>


<xsl:if test="not(fpml:optionEntitlement) and $productType='Equity Share Option'">
<error>
<context><xsl:value-of select="$newContext"/></context>
<text>*** Missing optionEntitlement element in this context when product type is 'Equity Share Option'.</text>
</error>
</xsl:if>


<xsl:if test="fpml:optionEntitlement">
<xsl:call-template name="isValidIntegerNumber">
<xsl:with-param name="elementName">optionEntitlement</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:optionEntitlement"/></xsl:with-param>
<xsl:with-param name="minIncl">1</xsl:with-param>
<xsl:with-param name="maxIncl">1</xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>


<xsl:if test="$productType = 'Equity Share Option' and fpml:multiplier">
<error>
<context><xsl:value-of select="$newContext"/></context>
<text>*** Unexpected multiplier element encountered in this context. Element must not be present when product type is 'Equity Share Option'.</text>
</error>
</xsl:if>


<xsl:if test="$productType = 'Equity Index Option' and fpml:multiplier and not($docsType='Equity Options (AEJ)')">
<error>
<context><xsl:value-of select="$newContext"/></context>
<text>*** Unexpected multiplier element encountered in this context. Element must not be present when product type is 'Equity Index Option' and Docs Type is not 'Equity Options (AEJ)'.</text>
</error>
</xsl:if>


<xsl:choose>
<xsl:when test="fpml:multiplier">
<xsl:call-template name="isValidIntegerNumber">
<xsl:with-param name="elementName">multiplier</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:multiplier"/></xsl:with-param>
<xsl:with-param name="minIncl">1</xsl:with-param>
<xsl:with-param name="maxIncl">1000000000</xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:when>
</xsl:choose>

</xsl:template>


<xsl:template match="fpml:underlyer">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="fpml:basket">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected basket element encountered in this context.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:singleUnderlyer">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

</xsl:template>


<xsl:template match="fpml:singleUnderlyer">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="not(fpml:equity) and ($productType = 'Equity Share Option' or $productType = 'Share Variance Swap')">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing equity element when product type is 'Equity Share Option' or 'Share Variance Swap'.</text></error>
</xsl:if>


<xsl:if test="not(fpml:index) and ($productType = 'Equity Index Option' or $productType = 'Index Variance Swap')">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing index element when product type is 'Equity Index Option' or 'Index Variance Swap'.</text></error>
</xsl:if>


<xsl:if test="fpml:openUnits">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected openUnits element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:dividendPayout">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected dividendPayout element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:couponPayout">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected couponPayout element encountered in this context.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:equity|fpml:index">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

</xsl:template>


<xsl:template match="fpml:equity|fpml:index">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="not(count(fpml:instrumentId)&gt;=1)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** The instrumentId element must occur at least once in this context</text></error>
</xsl:if>


<xsl:if test="count(fpml:instrumentId)&gt;2">
<error><context><xsl:value-of select="$newContext"/></context><text>*** The instrumentId element may not occur more than twice in this context</text></error>
</xsl:if>


<xsl:if test="fpml:currency">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected currency element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:clearanceSystem">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected clearanceSystem element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:definition">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected definition element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="ancestor::fpml:swDeltaCross and fpml:relatedExchangeId">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected relatedExchangeId element encountered in this context when ancestor is swDeltaCross.</text></error>
</xsl:if>


<xsl:if test="$productType='Equity Share Option' and $docsType='Equity Options (Japan)' and fpml:relatedExchangeId">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected relatedExchangeId element encountered in this context when product type is 'Equity Share Option' and Docs Type is 'Equity Options (Japan)</text></error>
</xsl:if>


<xsl:if test="fpml:relatedExchangeId and not (fpml:instrumentId = '.NSEI') and  ($docsType='Equity Options (AEJ)' or $docsType='Variance Swap (AEJ)')">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected  relatedExchangeId encountered in this context when Docs Type is 'Equity Options (AEJ)' or 'Variance Swap (AEJ)' and instrumentId is not equal to '.NSEI'.</text></error>
</xsl:if>


<xsl:if test="fpml:relatedExchangeId and ($docsType='Equity Options (Americas)' or  $docsType='Variance Swap (Americas)')">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected  relatedExchangeId encountered in this context when Docs Type is 'Equity Options (Americas)' or 'Variance Swap (Americas)'.</text></error>
</xsl:if>


<xsl:if test="fpml:optionsExchangeId">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected optionsExchangeId element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:futureId">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected futureId element encountered in this context.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:instrumentId">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

<xsl:apply-templates select="fpml:relatedExchangeId">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

</xsl:template>


<xsl:template match="fpml:future">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="not(count(fpml:instrumentId)=1)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** The instrumentId element must occur once only in this context</text></error>
</xsl:if>


<xsl:if test="not(fpml:instrumentId/@instrumentIdScheme = 'http://www.swapswire.com/spec/2005/future-id-1-0')">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Invalid instrumentId/@instrumentIdScheme attribute value. It must equal 'http://www.swapswire.com/spec/2005/future-id-1-0'</text></error>
</xsl:if>


<xsl:if test="fpml:currency">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected currency element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:exchangeId">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected exchangeId element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:clearanceSystem">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected clearanceSystem element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:definition">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected definition element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:relatedExchangeId">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected relatedExchangeId element encountered in this context.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:relatedExchangeId">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>


<xsl:if test="fpml:optionsExchangeId">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected optionsExchangeId element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:multiplier">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected multiplier element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:futureContractReference">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected futureContractReference element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="not(fpml:maturity)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing maturity element.</text></error>
</xsl:if>

</xsl:template>


<xsl:template match="fpml:relatedExchangeId">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/>[<xsl:number value="position()"/>]</xsl:variable>


<xsl:choose>
<xsl:when test="@exchangeIdScheme='http://www.fpml.org/spec/2002/exchange-id-REC-1-0'"/>
<xsl:otherwise>
<error><context><xsl:value-of select="$newContext"/></context><text>*** @exchangeIdScheme value is invalid. Value = '<xsl:value-of select="@exchangeIdScheme"/>'.</text></error>
</xsl:otherwise>
</xsl:choose>

</xsl:template>


<xsl:template match="fpml:equityExercise">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="fpml:equityBermudaExercise">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected equityBermudaExercise element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:equityAmericanExercise and $docsType='Equity Options (Japan)'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected equityAmericanExercise element in this context when Docs Type is 'Equity Options (Japan)'. Only European Style options can be confirmed under the Japanse Master Confirmation.</text></error>
</xsl:if>


<xsl:if test="$productType='Equity Share Option' or $productType='Equity Index Option'">
<xsl:if test="not(fpml:automaticExercise[.='true'])">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Invalid automaticExercise element value. Must contain 'true' when product type is 'Equity Share Option' or 'Equity Index Option'.</text></error>
</xsl:if>
</xsl:if>


<xsl:if test="fpml:makeWholeProvisions">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected makeWholeProvisions element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:prePayment">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected prePayment element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="(fpml:settlementDate and fpml:settlementType = 'Physical') or (fpml:settlementDate and fpml:settlementType = 'Election' and /fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:swExtendedTradeDetails/fpml:swEquityOptionDetails/fpml:swDefaultSettlementMethod != 'Cash')">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected settlementDate element encountered in this context when settlementType is 'Physical' or when settlementType is 'Election' and swDefaultSettlementMethod is not equal to 'Cash'. settlementDate only applies to cash settled options or to options for which Settlement Election applies and the default settlement method is 'Cash'.</text></error>
</xsl:if>


<xsl:if test="not(fpml:settlementCurrency = //fpml:FpML/fpml:trade/fpml:equityOptionTransactionSupplement/fpml:equityPremium/fpml:paymentAmount/fpml:currency)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** settlementCurrency must equal //FpML/trade/equityOptionTransactionSupplement/equityPremium/paymentAmount/currency.</text></error>
</xsl:if>


<xsl:if test="fpml:settlementPriceSource">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected settlementPriceSource element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="not(fpml:settlementType[.='Cash']) and $productType='Equity Index Option'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Invalid settlementType element encountered in this context when product type is 'Equity Index Option'. Value = '<xsl:value-of select="fpml:settlementType"/>'. Index options must be cash settled.</text></error>
</xsl:if>


<xsl:if test="not(fpml:settlementType[.='Physical']) and $productType='Equity Share Option' and $docsType='Equity Options (Japan)'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Invalid settlementType element encountered in this context when Docs Type is 'Equity Options (Japan)' and product type = 'Equity Share Option'. Share Options confirmed under the Japanse Master Confirmation.must be physically settled.</text></error>
</xsl:if>


<xsl:if test="fpml:settlementType = 'Election'">
<xsl:if test="not($productType='Equity Share Option' and $docsType='Equity Options (Americas)')">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Invalid settlementType 'Election' in this context. 'Election' is valid only when product type is 'Equity Share Option' and Docs Type is 'Equity Options (Americas)'.</text></error>
</xsl:if>
</xsl:if>


<xsl:if test="fpml:settlementType='Election' and not(/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:swExtendedTradeDetails/fpml:swEquityOptionDetails/fpml:swDefaultSettlementMethod)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** If settlementType is equal to 'Election' then swEquityOptionDetails/swDefaultSettlementMethod must be present.</text></error>
</xsl:if>


<xsl:if test="/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:swExtendedTradeDetails/fpml:swEquityOptionDetails/fpml:swDefaultSettlementMethod and fpml:settlementType!='Election'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** If settlementType is not equal to 'Election' then swEquityOptionDetails/swDefaultSettlementMethod must not be present.</text></error>
</xsl:if>


<xsl:if test="fpml:settlementMethodElectionDate">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected settlementMethodElectionDate element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:settlementMethodElectingPartyReference">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected settlementMethodElectingPartyReference element encountered in this context.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:equityEuropeanExercise|fpml:equityAmericanExercise">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

<xsl:apply-templates select="fpml:settlementDate">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

<xsl:apply-templates select="fpml:equityValuation">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

</xsl:template>


<xsl:template match="fpml:equityValuation">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="$productType = 'Equity Share Option' or $productType='Equity Index Option'">
<xsl:if test="(./@id !='valuationDate' or not(./@id)) and //fpml:equityExercise/fpml:settlementDate">
<error><context><xsl:value-of select="$newContext"/></context><text>*** @id must be present and must be equal to "valuationDate" in this context if //equityExercise/settlementDate is present and product type is 'Equity Share Option' or 'Equity Index Option'. Value = "<xsl:value-of select="./@id"/>".</text></error>
</xsl:if>
</xsl:if>


<xsl:if test="$productType = 'Share Variance Swap' or $productType='Index Variance Swap'">
<xsl:if test="(./@id !='valuationDate' or not(./@id))">
<error><context><xsl:value-of select="$newContext"/></context><text>*** @id must be present and must be equal to "valuationDate" in this context if product type is 'Share Variance Swap' or 'Index Variance Swap'. Value = "<xsl:value-of select="./@id"/>".</text></error>
</xsl:if>
</xsl:if>


<xsl:if test="fpml:valuationDate and ($productType = 'Equity Share Option' or $productType='Equity Index Option')">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected valuationDate element encountered in this context when product type is 'Equity Share Option' or 'Equity Index Option'.</text></error>
</xsl:if>


<xsl:if test="fpml:valuationDates">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected valuationDates element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:valuationTimeType">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected valuationTimeType element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:valuationTime">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected valuationTime element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:futuresPriceValuation and ($productType = 'Share Variance Swap' or $productType='Equity Share Option')">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected futuresPriceValuation element encountered in this context when product type is 'Share Variance Swap' or 'Equity Share Option'.</text></error>
</xsl:if>


<xsl:if test="fpml:futuresPriceValuation and  ($productType='Equity Index Option' and not ($docsType='Equity Options (AEJ)' or $docsType='Equity Options (Americas)'))">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected futuresPriceValuation element encountered in this context when product type is 'Equity Index Option' and Docs Type is not 'Equity Options (AEJ)' or 'Equity Options (Americas)'.</text></error>
</xsl:if>


<xsl:choose>
<xsl:when test="fpml:futuresPriceValuation">
<xsl:call-template name="isValidBoolean">
<xsl:with-param name="elementName">futuresPriceValuation</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:futuresPriceValuation"/></xsl:with-param>
<xsl:with-param name="testNumber"></xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:when>
</xsl:choose>


<xsl:if test="fpml:optionsPriceValuation">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected optionsPriceValuation element encountered in this context.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:valuationDate">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

</xsl:template>


<xsl:template match="fpml:valuationDate">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="fpml:relativeDate">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected relativeDate element encountered in this context.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:adjustableDate">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

</xsl:template>


<xsl:template match="fpml:settlementDate">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="fpml:adjustableDate">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected adjustableDate element encountered in this context.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:relativeDate">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

</xsl:template>


<xsl:template match="fpml:relativeDate">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:call-template name="isValidPeriodMultiplier">
<xsl:with-param name="elementName">periodMultiplier</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:periodMultiplier"/></xsl:with-param>
<xsl:with-param name="testNumber"></xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>


<xsl:if test="fpml:period!='D'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** period must be equal to 'D' in this context. Value = '<xsl:value-of select="fpml:period"/>'</text></error>
</xsl:if>


<xsl:if test="fpml:dayType != 'CurrencyBusiness'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** dayType must be equal to 'CurrencyBusiness' in this context. Value = '<xsl:value-of select="fpml:dayType"/>'</text></error>
</xsl:if>


<xsl:if test="fpml:businessDayConvention != 'NotApplicable'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** businessDayConvention must be equal to 'NotApplicable' in this context. Value = '<xsl:value-of select="fpml:businessDayConvention"/>'</text></error>
</xsl:if>


<xsl:if test="fpml:businessCentersReference">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected businessCentersReference element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:businessCenters">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected businessCenters element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:dateRelativeTo/@href != 'valuationDate'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** dateRelativeTo/@href must be equal to 'valuationDate' in this context. Value = '<xsl:value-of select="fpml:dateRelativeTo/@href"/>'</text></error>
</xsl:if>

</xsl:template>


<xsl:template match="fpml:fxFeature">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:call-template name="isValidReferenceCurrency">
<xsl:with-param name="elementName">referenceCurrency</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:referenceCurrency"/></xsl:with-param>
<xsl:with-param name="testNumber"></xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>


<xsl:if test="fpml:composite|fpml:crossCurrency">
<xsl:apply-templates select="fpml:composite|fpml:crossCurrency">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>
</xsl:if>

<xsl:if test="fpml:quanto">
<xsl:apply-templates select="fpml:quanto">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>
</xsl:if>

</xsl:template>


<xsl:template match="fpml:composite|fpml:crossCurrency">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="fpml:determinationMethod">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected determinationMethod in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:relativeDate">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected relativeDate in this context.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:fxSpotRateSource">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

</xsl:template>


<xsl:template match="fpml:fxSpotRateSource">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>

<xsl:apply-templates select="fpml:primaryRateSource">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>


<xsl:if test="fpml:secondaryRateSource">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected secondaryRateSource in this context.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:fixingTime">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

</xsl:template>


<xsl:template match="fpml:primaryRateSource">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:call-template name="isValidRateSource">
<xsl:with-param name="elementName">rateSource</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:rateSource"/></xsl:with-param>
<xsl:with-param name="testNumber"></xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>


<xsl:variable name="rateSourcePageScheme"><xsl:value-of select="fpml:rateSourcePage/@rateSourcePageScheme"/></xsl:variable>
<xsl:if test="$rateSourcePageScheme != 'http://www.swapswire.com/spec/2006/rate-source-page-1-0'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing or unrecognised rateSourcePage/@rateSourcePageScheme attribute value. Value = '<xsl:value-of select="$rateSourcePageScheme"/>'.</text></error>
</xsl:if>


<xsl:call-template name="isValidRateSourcePage">
<xsl:with-param name="elementName">rateSourcePage</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:rateSourcePage"/></xsl:with-param>
<xsl:with-param name="testNumber"></xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>


<xsl:if test="fpml:rateSourcePageHeading">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected rateSourcePageHeading in this context.</text></error>
</xsl:if>

</xsl:template>


<xsl:template match="fpml:fixingTime">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:call-template name="isValidTime">
<xsl:with-param name="elementName">hourMinuteTime</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:hourMinuteTime"/></xsl:with-param>
<xsl:with-param name="testNumber"></xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>


<xsl:call-template name="isValidBusinessCenter">
<xsl:with-param name="elementName">businessCenter</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:businessCenter"/></xsl:with-param>
<xsl:with-param name="testNumber"></xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>

</xsl:template>


<xsl:template match="fpml:quanto">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="not(count(child::*)=0)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected child elements  encountered in this context.</text></error>
</xsl:if>

</xsl:template>


<xsl:template match="fpml:strike">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="$docsType='Equity Options (Europe)' or $docsType='Equity Options (Americas)'">
<xsl:call-template name="isValidNumber">
<xsl:with-param name="elementName">strikePrice</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:strikePrice"/></xsl:with-param>
<xsl:with-param name="minIncl">0</xsl:with-param>
<xsl:with-param name="maxIncl">1000000.00000</xsl:with-param>
<xsl:with-param name="maxDecs">5</xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>


<xsl:if test="$docsType='Equity Options (Japan)' or $docsType='Equity Options (AEJ)'">
<xsl:call-template name="isValidNumber">
<xsl:with-param name="elementName">strikePrice</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:strikePrice"/></xsl:with-param>
<xsl:with-param name="minIncl">0</xsl:with-param>
<xsl:with-param name="maxIncl">9999999.999999</xsl:with-param>
<xsl:with-param name="maxDecs">6</xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>


<xsl:if test="fpml:strikePercentage">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected strikePercentage element encountered in this context.</text></error>
</xsl:if>





<xsl:if test="$productType='Equity Share Option'">

<xsl:if test="not(fpml:currency)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing currency element. Required in this context.</text></error>
</xsl:if>

<xsl:if test="not(fpml:currency = //fpml:FpML/fpml:trade/fpml:equityOptionTransactionSupplement/fpml:equityPremium/fpml:paymentAmount/fpml:currency) and not(/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equityOptionTransactionSupplement/fpml:fxFeature/fpml:crossCurrency or /fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equityOptionTransactionSupplement/fpml:fxFeature/fpml:quanto)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** The currency must equal /equityPremium/paymentAmount/currency unless option is Cross-Currency or Quanto settled.</text></error>
</xsl:if>

<xsl:if test="not(fpml:currency = //fpml:FpML/fpml:trade/fpml:equityOptionTransactionSupplement/fpml:fxFeature/fpml:referenceCurrency) and (/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equityOptionTransactionSupplement/fpml:fxFeature/fpml:crossCurrency or /fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equityOptionTransactionSupplement/fpml:fxFeature/fpml:quanto)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** The currency must equal fxFeature/referenceCurrency when option is Cross-Currency or Quanto settled.</text></error>
</xsl:if>

</xsl:if>


<xsl:if test="fpml:currency and $productType='Equity Index Option'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected currency element encountered in this context when product type is 'Equity Index Option'.</text></error>
</xsl:if>

</xsl:template>


<xsl:template match="fpml:equityPremium">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="not(fpml:payerPartyReference/@href = /fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equityOptionTransactionSupplement/fpml:buyerPartyReference/@href)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Invalid payerPartyReference/@href attribute value. The payerPartyReference/@href must be equal to //FpML/trade/equityOptionTransactionSupplement/buyerPartyReference/@href (payer of premium is option buyer).</text></error>
</xsl:if>


<xsl:if test="not(fpml:receiverPartyReference/@href = /fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equityOptionTransactionSupplement/fpml:sellerPartyReference/@href)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Invalid receiverPartyReference/@href attribute value. The receiverPartyReference/@href must be equal to //FpML/trade/equityOptionTransactionSupplement/sellerPartyReference/@href (receiver of premium is option seller).</text></error>
</xsl:if>


<xsl:if test="fpml:premiumType">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected premiumType element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="not(fpml:paymentAmount)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing paymentAmount element. Required in this context.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:paymentAmount">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>


<xsl:if test="not(fpml:paymentAmount/fpml:currency = fpml:pricePerOption/fpml:currency)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** The paymentAmount/currency and pricePerOption/currency must be equal.</text></error>
</xsl:if>


<xsl:if test="not(fpml:paymentDate)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing paymentDate element. Required in this context.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:paymentDate">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>


<xsl:if test="fpml:swapPremium">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected swapPremium element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="not(fpml:pricePerOption)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing pricePerOption element. Required in this context.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:pricePerOption">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>


<xsl:if test="fpml:percentageOfNotional">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected percentageOfNotional element encountered in this context.</text></error>
</xsl:if>

</xsl:template>


<xsl:template match="fpml:paymentDate">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>

<xsl:apply-templates select="fpml:dateAdjustments">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

</xsl:template>


<xsl:template match="fpml:dateAdjustments">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="not(fpml:businessDayConvention[.='NotApplicable'])">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Invalid businessDayConvention element value. Must contain 'NotApplicable' when product type is 'Equity Share Option', 'Equity Index Option', 'Share Variance Swap' or 'Index Variance Swap'.</text></error>
</xsl:if>


<xsl:if test="fpml:businessCenters">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected businessCenters element encountered in this context when product type is 'Equity Share Option', 'Equity Index Option', 'Share Variance Swap' or 'Index Variance Swap'.</text></error>
</xsl:if>


<xsl:if test="fpml:businessCentersReference">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected businessCentersReference element encountered in this context.</text></error>
</xsl:if>

</xsl:template>


<xsl:template match="fpml:pricePerOption">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="$docsType='Equity Options (Europe)' or $docsType='Equity Options (Americas)'">
<xsl:call-template name="isValidNumber">
<xsl:with-param name="elementName">amount</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:amount"/></xsl:with-param>
<xsl:with-param name="minIncl">0.00001</xsl:with-param>
<xsl:with-param name="maxIncl">9999.99999</xsl:with-param>
<xsl:with-param name="maxDecs">5</xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>


<xsl:if test=" $docsType='Equity Options (AEJ)'">
<xsl:call-template name="isValidNumber">
<xsl:with-param name="elementName">amount</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:amount"/></xsl:with-param>
<xsl:with-param name="minIncl">0.000001</xsl:with-param>
<xsl:with-param name="maxIncl">9999.999999</xsl:with-param>
<xsl:with-param name="maxDecs">6</xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>



<xsl:if test="$docsType='Equity Options (Japan)'">
<xsl:call-template name="isValidNumber">
<xsl:with-param name="elementName">amount</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:amount"/></xsl:with-param>
<xsl:with-param name="minIncl">0.00001</xsl:with-param>
<xsl:with-param name="maxIncl">999999.99999</xsl:with-param>
<xsl:with-param name="maxDecs">5</xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>

</xsl:template>



<xsl:template match="fpml:equityEuropeanExercise">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>

<xsl:apply-templates select="fpml:expirationDate">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>


<xsl:if test="fpml:equityExpirationTime">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected equityExpirationTime element encountered in this context.</text></error>
</xsl:if>


<xsl:call-template name="isValidEquityExpirationTimeType">
<xsl:with-param name="elementName">equityExpirationTimeType</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:equityExpirationTimeType"/></xsl:with-param>
<xsl:with-param name="testNumber"></xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>

</xsl:template>


<xsl:template match="fpml:expirationDate|fpml:commencementDate">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="fpml:relativeDate">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected relativeDate element encountered in this context.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:adjustableDate">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

</xsl:template>


<xsl:template match="fpml:equityAmericanExercise">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>

<xsl:apply-templates select="fpml:commencementDate">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

<xsl:apply-templates select="fpml:expirationDate">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>


<xsl:if test="not(fpml:commencementDate/fpml:adjustableDate/fpml:unadjustedDate = //fpml:FpML/fpml:trade/fpml:tradeHeader/fpml:tradeDate)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** The commencementDate/adjustableDate/unadjustedDate must equal the //FpML/trade/tradeHeader/tradeDate (American exercise period must commence on the trade date).</text></error>
</xsl:if>


<xsl:if test="fpml:latestExerciseTime">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected latestExerciseTime element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:latestExerciseTimeType">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected latestExerciseTimeType element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:equityExpirationTime">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected equityExpirationTime element encountered in this context.</text></error>
</xsl:if>


<xsl:call-template name="isValidEquityExpirationTimeType">
<xsl:with-param name="elementName">equityExpirationTimeType</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:equityExpirationTimeType"/></xsl:with-param>
<xsl:with-param name="testNumber"></xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>


<xsl:if test="fpml:equityMultipleExercise and not(//fpml:FpML/fpml:trade/fpml:equityOptionTransactionSupplement/fpml:equityExercise/fpml:equityAmericanExercise)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected equityMultipleExercise element encountered in this context when option is not American style.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:equityMultipleExercise">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

</xsl:template>


<xsl:template match="fpml:equityMultipleExercise">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="not(fpml:integralMultipleExercise)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing integralMultiple element in this context. When message includes equityMultipleExercise, the integralMultiple shoudl be specified.</text></error>
</xsl:if>


<xsl:if test="fpml:integralMultipleExercise">
<xsl:call-template name="isValidIntegerNumber">
<xsl:with-param name="elementName">integralMultipleExercise</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:integralMultipleExercise"/></xsl:with-param>
<xsl:with-param name="minIncl">1</xsl:with-param>
<xsl:with-param name="maxIncl">1000000</xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>


<xsl:if test="fpml:minumumNumberOfOptions">
<xsl:call-template name="isValidIntegerNumber">
<xsl:with-param name="elementName">minumumNumberOfOptions</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:minumumNumberOfOptions"/></xsl:with-param>
<xsl:with-param name="minIncl">1</xsl:with-param>
<xsl:with-param name="maxIncl">1000000</xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>



<xsl:variable name="maxNumberOfOptions">
<xsl:value-of select="fpml:maximumNumberOfOptions"/>
</xsl:variable>

<xsl:variable name="numberOfOptions">
<xsl:value-of select="//fpml:equityOptionTransactionSupplement/fpml:numberOfOptions"/>
</xsl:variable>

<xsl:if test="number($maxNumberOfOptions) != number($numberOfOptions)">
<error>
<context>
<xsl:value-of select="$newContext"/>
</context>
<text>*** maximumNumberOfOptions element should hold the same value as equityOptionTransactionSupplement/numberOfOptions.</text>
</error>
</xsl:if>

</xsl:template>




<xsl:template match="fpml:equitySwapTransactionSupplement">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:variable name="buyer"><xsl:value-of select="fpml:buyerPartyReference/@href"/></xsl:variable>
<xsl:if test="not(/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:party[@id=$buyer])">
<error><context><xsl:value-of select="$newContext"/></context><text>*** The buyerPartyReference/@href value does not match an //FpML/party/@id value for any party. Value = '<xsl:value-of select="$buyer"/>'.</text></error>
</xsl:if>


<xsl:variable name="seller"><xsl:value-of select="fpml:sellerPartyReference/@href"/></xsl:variable>
<xsl:if test="not(/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:party[@id=$seller])">
<error><context><xsl:value-of select="$newContext"/></context><text>*** The sellerPartyReference/@href value does not match an //FpML/party/@id value for any party. Value = '<xsl:value-of select="$seller"/>'.</text></error>
</xsl:if>


<xsl:if test="$buyer=$seller"><error><context><xsl:value-of select="$newContext"/></context><text>*** buyerPartyReference/@href and sellerPartyReference/@href values are the same.</text></error></xsl:if>


<xsl:if test="fpml:productType">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected productType element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:productId">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected productId element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:equityLeg">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected equityLeg element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:interestLeg">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected interestLeg element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:returnLeg">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected returnLeg element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:mutualEarlyTermination">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected mutualEarlyTermination element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:localJurisdiction">
<xsl:call-template name="isValidLocalJurisdiction">
<xsl:with-param name="elementName">localJurisdiction</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:localJurisdiction"/></xsl:with-param>
<xsl:with-param name="testNumber"></xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>

<xsl:apply-templates select="fpml:varianceLeg">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

</xsl:template>


<xsl:template match="fpml:varianceLeg">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:variable name="payer"><xsl:value-of select="fpml:payerPartyReference/@href"/></xsl:variable>
<xsl:if test="not(/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equitySwapTransactionSupplement/fpml:buyerPartyReference[@href=$payer])">
<error><context><xsl:value-of select="$newContext"/></context><text>*** The payerPartyReference/@href value does not match the /fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/trade/equitySwapTransactionSupplement/buyerPartyReference. Value = '<xsl:value-of select="$payer"/>'.</text></error>
</xsl:if>


<xsl:variable name="receiver"><xsl:value-of select="fpml:receiverPartyReference/@href"/></xsl:variable>
<xsl:if test="not(/fpml:SWDML/fpml:swLongFormTrade/fpml:swStructuredTradeDetails/fpml:FpML/fpml:trade/fpml:equitySwapTransactionSupplement/fpml:sellerPartyReference[@href=$receiver])">
<error><context><xsl:value-of select="$newContext"/></context><text>*** The receiverPartyReference/@href value does not match the //FpML/trade/equitySwapTransactionSupplement/sellerPartyReference. Value = '<xsl:value-of select="$receiver"/>'.</text></error>
</xsl:if>


<xsl:if test="$payer=$receiver"><error><context><xsl:value-of select="$newContext"/></context><text>*** payerPartyReference/@href and receiverPartyReference/@href values are the same.</text></error></xsl:if>


<xsl:if test="fpml:paymentFrequency">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected paymentFrequency element encountered in this context.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:underlyer">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

<xsl:apply-templates select="fpml:equityValuation">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

<xsl:apply-templates select="fpml:equityAmount">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

</xsl:template>


<xsl:template match="fpml:equityAmount">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="not(fpml:cashSettlement[.='true'])">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Invalid cashSettlement element value. Must contain 'true'.</text></error>
</xsl:if>


<xsl:if test="not(fpml:paymentCurrency)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing paymentCurrency element in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:referenceAmount">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected referenceAmount element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:formula">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected formula element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:encodedDescription">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected encodedDescription element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:calculationDates">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected calculationDates element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:optionsExchangeDividends">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected optionsExchangeDividends element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:additionalDividends">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected additionalDividends element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="not(fpml:observationStartDate)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing observationStartDate element in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:allDividends and ($productType = 'Index Variance Swap' or ($docsType='Variance Swap (Japan)' or $docsType='Variance Swap (Americas)'))">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected allDividends element encountered in this context when productType is 'Index Variance Swap' or Docs Type is 'Variance Swap (Japan)' or Docs Type is 'Variance Swap (Americas)'.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:variance">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

<xsl:apply-templates select="fpml:cashSettlementPaymentDate">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

<xsl:apply-templates select="fpml:observationStartDate">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

</xsl:template>


<xsl:template match="fpml:variance">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="fpml:expiringLevel and $productType = 'Share Variance Swap'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected expiringLevel element in this context. Element must not be present when productType is 'Share Variance Swap'.</text></error>
</xsl:if>


<xsl:if test="fpml:expiringLevel and $docsType = 'Variance Swap (Japan)'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected expiringLevel element in this context. Element must not be present when Docs Type is  'Variance Swap (Japan)''.</text></error>
</xsl:if>


<xsl:if test="not(fpml:expectedN)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing expectedN element in this context. Element must be present for all Variance Swap products.</text></error>
</xsl:if>


<xsl:if test="fpml:varianceCap[.='true'] and not(fpml:unadjustedVarianceCap)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing unadjustedVarianceCap element when varianceCap is set to 'true'.</text></error>
</xsl:if>


<xsl:if test="fpml:exchangeTradedContractNearest">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected exchangeTradedContractNearest element encountered in this context.</text></error>
</xsl:if>


<xsl:if test="not(fpml:vegaNotionalAmount)">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing vegaNotionalAmount element in this context.</text></error>
</xsl:if>


<xsl:if test="fpml:vegaNotionalAmount">
<xsl:call-template name="isValidNumber">
<xsl:with-param name="elementName">vegaNotionalAmount</xsl:with-param>
<xsl:with-param name="elementValue"><xsl:value-of select="fpml:vegaNotionalAmount"/></xsl:with-param>
<xsl:with-param name="minIncl">0.01</xsl:with-param>
<xsl:with-param name="maxIncl">999999999999.99</xsl:with-param>
<xsl:with-param name="maxDecs">2</xsl:with-param>
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:call-template>
</xsl:if>


<xsl:if test="fpml:fxFeature and $docsType != 'Variance Swap (AEJ)'">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected fxFeature element in this context. Element must not be present when Docs Type is not 'Variance Swap (AEJ)'.</text></error>
</xsl:if>


<xsl:if test="not(fpml:fxFeature) and $docsType='Variance Swap (AEJ)'">
<xsl:choose>
<xsl:when test="fpml:varianceAmount/fpml:currency = 'AUD'"/>
<xsl:when test="fpml:varianceAmount/fpml:currency = 'HKD'"/>
<xsl:when test="fpml:varianceAmount/fpml:currency = 'NZD'"/>
<xsl:when test="fpml:varianceAmount/fpml:currency = 'SGD'"/>
<xsl:otherwise>
<error><context><xsl:value-of select="$newContext"/></context><text>*** Missing fxFeature element  when Docs Type is 'Variance Swap (AEJ)' and varianceAmount/currency is a non-deliverable currency.</text></error>
</xsl:otherwise>
</xsl:choose>
</xsl:if>

<xsl:apply-templates select="fpml:fxFeature">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

</xsl:template>


<xsl:template match="fpml:cashSettlementPaymentDate">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="fpml:adjustableDate">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected adjustableDate element encountered in this context.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:relativeDate">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

</xsl:template>


<xsl:template match="fpml:observationStartDate">
<xsl:param name="context"/>
<xsl:variable name="newContext"><xsl:value-of select="$context"/>/<xsl:value-of select="local-name()"/></xsl:variable>


<xsl:if test="fpml:relativeDate">
<error><context><xsl:value-of select="$newContext"/></context><text>*** Unexpected relativeDate element encountered in this context.</text></error>
</xsl:if>

<xsl:apply-templates select="fpml:adjustableDate">
<xsl:with-param name="context"><xsl:value-of select="$newContext"/></xsl:with-param>
</xsl:apply-templates>

</xsl:template>




<xsl:template name="isValidBoolean">
<xsl:param name="elementName"/>
<xsl:param name="elementValue"/>
<xsl:param name="testNumber"/>
<xsl:param name="context"/>
<xsl:variable name="errorText">Empty or invalid <xsl:value-of select="$elementName"/> element. Value = '<xsl:value-of select="$elementValue"/>'.</xsl:variable>

<xsl:choose>
<xsl:when test="$elementValue='true'"/>
<xsl:when test="$elementValue='false'"/>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>
</xsl:template>


<xsl:template name="isValidBusinessCenter">
<xsl:param name="elementName"/>
<xsl:param name="elementValue"/>
<xsl:param name="testNumber"/>
<xsl:param name="context"/>
<xsl:variable name="errorText">Empty or invalid <xsl:value-of select="$elementName"/> element. Value = '<xsl:value-of select="$elementValue"/>'.</xsl:variable>

<xsl:choose>
<xsl:when test="$elementValue='BEBR'"/>
<xsl:when test="$elementValue='CHZU'"/>
<xsl:when test="$elementValue='CATO'"/>
<xsl:when test="$elementValue='DKCO'"/>
<xsl:when test="$elementValue='EUTA'"/>
<xsl:when test="$elementValue='FRPA'"/>
<xsl:when test="$elementValue='GBLO'"/>
<xsl:when test="$elementValue='JPTO'"/>
<xsl:when test="$elementValue='NOOS'"/>
<xsl:when test="$elementValue='SEST'"/>
<xsl:when test="$elementValue='USNY'"/>

<xsl:when test="$elementValue='ARBA'"/>
<xsl:when test="$elementValue='ATVI'"/>
<xsl:when test="$elementValue='AUME'"/>
<xsl:when test="$elementValue='AUSY'"/>
<xsl:when test="$elementValue='BRSP'"/>
<xsl:when test="$elementValue='CAMO'"/>
<xsl:when test="$elementValue='CHGE'"/>
<xsl:when test="$elementValue='CLSA'"/>
<xsl:when test="$elementValue='CNBE'"/>
<xsl:when test="$elementValue='CZPR'"/>
<xsl:when test="$elementValue='DEDU'"/>
<xsl:when test="$elementValue='DEFR'"/>
<xsl:when test="$elementValue='EETA'"/>
<xsl:when test="$elementValue='ESMA'"/>
<xsl:when test="$elementValue='FIHE'"/>
<xsl:when test="$elementValue='GRAT'"/>
<xsl:when test="$elementValue='HKHK'"/>
<xsl:when test="$elementValue='HUBU'"/>
<xsl:when test="$elementValue='IDJA'"/>
<xsl:when test="$elementValue='IEDU'"/>
<xsl:when test="$elementValue='ILTA'"/>
<xsl:when test="$elementValue='INMU'"/>
<xsl:when test="$elementValue='ITMI'"/>
<xsl:when test="$elementValue='ITRO'"/>
<xsl:when test="$elementValue='KRSE'"/>
<xsl:when test="$elementValue='LBBE'"/>
<xsl:when test="$elementValue='LULU'"/>
<xsl:when test="$elementValue='MXMC'"/>
<xsl:when test="$elementValue='MYKL'"/>
<xsl:when test="$elementValue='NLAM'"/>
<xsl:when test="$elementValue='NYFD'"/>
<xsl:when test="$elementValue='NYSE'"/>
<xsl:when test="$elementValue='NZAU'"/>
<xsl:when test="$elementValue='NZWE'"/>
<xsl:when test="$elementValue='PAPC'"/>
<xsl:when test="$elementValue='PHMA'"/>
<xsl:when test="$elementValue='PLWA'"/>
<xsl:when test="$elementValue='PTLI'"/>
<xsl:when test="$elementValue='RUMO'"/>
<xsl:when test="$elementValue='SARI'"/>
<xsl:when test="$elementValue='SGSI'"/>
<xsl:when test="$elementValue='SKBR'"/>
<xsl:when test="$elementValue='THBA'"/>
<xsl:when test="$elementValue='TRAN'"/>
<xsl:when test="$elementValue='TWTA'"/>
<xsl:when test="$elementValue='USCH'"/>
<xsl:when test="$elementValue='USGS'"/>
<xsl:when test="$elementValue='USLA'"/>
<xsl:when test="$elementValue='VECA'"/>
<xsl:when test="$elementValue='ZAJO'"/>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>

</xsl:template>


<xsl:template name="isValidEquityConfirmationType">
<xsl:param name="elementName"/>
<xsl:param name="elementValue"/>
<xsl:param name="testNumber"/>
<xsl:param name="context"/>
<xsl:variable name="errorText">Empty or invalid <xsl:value-of select="$elementName"/> element. Value = '<xsl:value-of select="$elementValue"/>'.</xsl:variable>

<xsl:choose>
<xsl:when test="$elementValue='Equity Options (AEJ)'"/>
<xsl:when test="$elementValue='ISDA2005EquityAsiaExcludingJapanInterdealer'"/>
<xsl:when test="$elementValue='Equity Options (Americas)'"/>
<xsl:when test="$elementValue='ISDA2004EquityAmericasInterdealer'"/>
<xsl:when test="$elementValue='Equity Options (Europe)'"/>
<xsl:when test="$elementValue='2004EquityEuropeanInterdealer'"/>
<xsl:when test="$elementValue='ISDA2007EquityEuropean'"/>
<xsl:when test="$elementValue='Equity Options (Japan)'"/>
<xsl:when test="$elementValue='ISDA2005EquityJapaneseInterdealer'"/>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>

</xsl:template>


<xsl:template name="isValidDate">
<xsl:param name="elementName"/>
<xsl:param name="elementValue"/>
<xsl:param name="testNumber"/>
<xsl:param name="context"/>
<xsl:variable name="errorText">Invalid date format for <xsl:value-of select="$elementName"/>. Value = '<xsl:value-of select="$elementValue"/>'.</xsl:variable>

<xsl:if test="not(string-length($elementValue)=10)">
<error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error>
</xsl:if>



<xsl:choose>
<xsl:when test="substring($elementValue,5,1)='-'">
<xsl:choose>
<xsl:when test="substring($elementValue,8,1)='-'">
<xsl:choose>
<xsl:when test="string(number(substring($elementValue,1,1)))!= 'NaN'">
<xsl:choose>
<xsl:when test="string(number(substring($elementValue,2,1)))!= 'NaN'">
<xsl:choose>
<xsl:when test="string(number(substring($elementValue,3,1)))!= 'NaN'">
<xsl:choose>
<xsl:when test="string(number(substring($elementValue,4,1)))!= 'NaN'">
<xsl:choose>
<xsl:when test="string(number(substring($elementValue,6,1)))!= 'NaN'">
<xsl:choose>
<xsl:when test="string(number(substring($elementValue,7,1)))!= 'NaN'">
<xsl:choose>
<xsl:when test="string(number(substring($elementValue,9,1)))!= 'NaN'">
<xsl:choose>
<xsl:when test="string(number(substring($elementValue,10,1)))!= 'NaN'">
<xsl:choose>
<xsl:when test="number(substring($elementValue,1,4)) != 0">
<xsl:choose>
<xsl:when test="number(substring($elementValue,6,2)) != 0 and number(substring($elementValue,6,2)) &lt; 13">
<xsl:choose>
<xsl:when test="number(substring($elementValue,9,2)) != 0 and number(substring($elementValue,9,2)) &lt; 32">
</xsl:when>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>
</xsl:when>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>
</xsl:when>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>
</xsl:when>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>
</xsl:when>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>
</xsl:when>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>
</xsl:when>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>
</xsl:when>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>
</xsl:when>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>
</xsl:when>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>
</xsl:when>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>
</xsl:when>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>
</xsl:when>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>
</xsl:template>


<xsl:template name="isValidEquityExpirationTimeType">
<xsl:param name="elementName"/>
<xsl:param name="elementValue"/>
<xsl:param name="testNumber"/>
<xsl:param name="context"/>
<xsl:variable name="errorText">Empty or invalid <xsl:value-of select="$elementName"/> element. Value = '<xsl:value-of select="$elementValue"/>'.</xsl:variable>

<xsl:choose>
<xsl:when test="$productType = 'Equity Index Option' and $docsType='Equity Options (Europe)'">
<xsl:choose>
<xsl:when test="$elementValue='OSP'"/>
<xsl:when test="$elementValue='Open'"/>
<xsl:when test="$elementValue='Close'"/>
<xsl:otherwise>
<error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/> When product type is 'Equity Index Option' and Docs Type is 'Equity Options (Europe)', the permitted values are 'OSP', 'Open' or 'Close'.</text></error>
</xsl:otherwise>
</xsl:choose>
</xsl:when>
<xsl:when test="$productType = 'Equity Share Option' and $docsType='Equity Options (Europe)'">
<xsl:choose>
<xsl:when test="$elementValue='AsSpecifiedInMasterConfirmation'"/>
<xsl:when test="$elementValue='Open'"/>
<xsl:when test="$elementValue='Close'"/>
<xsl:otherwise>
<error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/> When product type is 'Equity Share Option' and Docs Type is 'Equity Options (Europe)', the permitted values are 'AsSpecifiedInMasterConfirmation', 'Open' or 'Close'.</text></error>
</xsl:otherwise>
</xsl:choose>
</xsl:when>
<xsl:otherwise>
<xsl:choose>
<xsl:when test="$elementValue='AsSpecifiedInMasterConfirmation'"/>
<xsl:otherwise>
<error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/> Element must be passed with a value of 'AsSpecifiedInMasterConfirmation' when Docs Type is 'Equity Options (Japan)' or 'Equity Options (Americas)'.</text></error>
</xsl:otherwise>
</xsl:choose>
</xsl:otherwise>
</xsl:choose>

</xsl:template>


<xsl:template name="isValidVarianceSwapConfirmationType">
<xsl:param name="elementName"/>
<xsl:param name="elementValue"/>
<xsl:param name="testNumber"/>
<xsl:param name="context"/>
<xsl:variable name="errorText">Empty or invalid <xsl:value-of select="$elementName"/> element. Value = '<xsl:value-of select="$elementValue"/>'.</xsl:variable>

<xsl:choose>
<xsl:when test="$elementValue='Variance Swap (AEJ)'"/>
<xsl:when test="$elementValue='ISDA2007VarianceSwapAsiaExcludingJapan'"/>
<xsl:when test="$elementValue='Variance Swap (Americas)'"/>
<xsl:when test="$elementValue='ISDA2004EquityAmericasInterdealer'"/>
<xsl:when test="$elementValue='ISDA2007VarianceSwapAmericas'"/>
<xsl:when test="$elementValue='Variance Swap (Europe)'"/>
<xsl:when test="$elementValue='2005VarianceSwapEuropeanInterdealer'"/>
<xsl:when test="$elementValue='ISDA2007VarianceSwapEuropean'"/>
<xsl:when test="$elementValue='Variance Swap (Japan)'"/>
<xsl:when test="$elementValue='ISDA2006VarianceSwapJapaneseInterdealer'"/>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>
</xsl:template>


<xsl:template name="isValidCurrency">
<xsl:param name="elementName"/>
<xsl:param name="elementValue"/>
<xsl:param name="testNumber"/>
<xsl:param name="context"/>
<xsl:variable name="errorText">Empty or invalid <xsl:value-of select="$elementName"/> element. Value = '<xsl:value-of select="$elementValue"/>'.</xsl:variable>

<xsl:choose>
<xsl:when test="$elementValue='CAD'"/>
<xsl:when test="$elementValue='CHF'"/>
<xsl:when test="$elementValue='DKK'"/>
<xsl:when test="$elementValue='EUR'"/>
<xsl:when test="$elementValue='GBP'"/>
<xsl:when test="$elementValue='JPY'"/>
<xsl:when test="$elementValue='NOK'"/>
<xsl:when test="$elementValue='SEK'"/>
<xsl:when test="$elementValue='USD'"/>
<xsl:when test="$elementValue='HKD'"/>
<xsl:when test="$elementValue='AUD'"/>
<xsl:when test="$elementValue='SGD'"/>
<xsl:when test="$elementValue='NZD'"/>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>
</xsl:template>


<xsl:template name="isValidInstrumentIdScheme">
<xsl:param name="elementName"/>
<xsl:param name="elementValue"/>
<xsl:param name="testNumber"/>
<xsl:param name="context"/>
<xsl:variable name="errorText">Empty or invalid <xsl:value-of select="$elementName"/> attribute. Value = '<xsl:value-of select="$elementValue"/>'.</xsl:variable>

<xsl:choose>
<xsl:when test="$elementValue='http://www.fpml.org/spec/2003/instrument-id-Reuters-RIC-1-0'"/>
<xsl:when test="$elementValue='http://www.fpml.org/spec/2002/instrument-id-ISIN-1-0'"/>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>
</xsl:template>


<xsl:template name="isValidIntegerNumber">
<xsl:param name="elementName"/>
<xsl:param name="elementValue"/>
<xsl:param name="minIncl"/>
<xsl:param name="maxIncl"/>
<xsl:param name="context"/>

<xsl:choose>
<xsl:when test="string(number($elementValue)) != 'NaN' and not(contains($elementValue,'.')) and not(contains($elementValue,' '))">
<xsl:if test="number($elementValue) &lt; $minIncl or number($elementValue) &gt; $maxIncl">
<error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$elementName"/> is outside allowable range; minIncl=<xsl:value-of select="$minIncl"/>, maxIncl=<xsl:value-of select="$maxIncl"/>. Value = '<xsl:value-of select="$elementValue"/>'.</text></error>
</xsl:if>
</xsl:when>
<xsl:otherwise>
<error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$elementName"/> is not a valid integer number. Value = '<xsl:value-of select="$elementValue"/>'.</text></error>
</xsl:otherwise>
</xsl:choose>

</xsl:template>


<xsl:template name="isValidLocalJurisdiction">
<xsl:param name="elementName"/>
<xsl:param name="elementValue"/>
<xsl:param name="testNumber"/>
<xsl:param name="context"/>
<xsl:variable name="errorText">Empty or invalid <xsl:value-of select="$elementName"/> element. Value = '<xsl:value-of select="$elementValue"/>'.</xsl:variable>

<xsl:choose>
<xsl:when test="$elementValue='Not Applicable'"/>
<xsl:when test="$elementValue='India'"/>
<xsl:when test="$elementValue='Indonesia'"/>
<xsl:when test="$elementValue='Korea'"/>
<xsl:when test="$elementValue='Malaysia'"/>
<xsl:when test="$elementValue='Taiwan'"/>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>

</xsl:template>


<xsl:template name="isValidNumber">
<xsl:param name="elementName"/>
<xsl:param name="elementValue"/>
<xsl:param name="minIncl"/>
<xsl:param name="maxIncl"/>
<xsl:param name="maxDecs"/>
<xsl:param name="context"/>

<xsl:choose>
<xsl:when test="string(number($elementValue)) !='NaN' and not(contains($elementValue,' ')) and not(contains($elementValue,'e'))">
<xsl:if test="number($elementValue) &lt; $minIncl or number($elementValue) &gt; $maxIncl">
<error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$elementName"/> is outside allowable range; minIncl=<xsl:value-of select="$minIncl"/>, maxIncl=<xsl:value-of select="$maxIncl"/>. Value = '<xsl:value-of select="$elementValue"/>'.</text></error>
</xsl:if>
</xsl:when>
<xsl:otherwise>
<error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$elementName"/> is not a valid number. Value = '<xsl:value-of select="$elementValue"/>'.</text></error>
</xsl:otherwise>
</xsl:choose>

<xsl:if test="string-length(substring-after($elementValue,'.')) &gt; $maxDecs"><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$elementName"/> has too many decimal places; maxDecs=<xsl:value-of select="$maxDecs"/>. Value = '<xsl:value-of select="$elementValue"/>'.</text></error></xsl:if>

</xsl:template>


<xsl:template name="isValidPeriod">
<xsl:param name="elementName"/>
<xsl:param name="elementValue"/>
<xsl:param name="testNumber"/>
<xsl:param name="context"/>
<xsl:variable name="errorText">Empty or invalid <xsl:value-of select="$elementName"/> element for product type of '<xsl:value-of select="$productType"/>'. Value = '<xsl:value-of select="$elementValue"/>'.</xsl:variable>

<xsl:if test="not($productType='OIS')">
<xsl:choose>
<xsl:when test="$elementValue='D'"/>
<xsl:when test="$elementValue='M'"/>
<xsl:when test="$elementValue='Y'"/>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>
</xsl:if>

<xsl:if test="$productType='OIS'">
<xsl:choose>
<xsl:when test="$elementValue='D'"/>
<xsl:when test="$elementValue='M'"/>
<xsl:when test="$elementValue='Y'"/>
<xsl:when test="$elementValue='T'"/>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>
</xsl:if>

</xsl:template>


<xsl:template name="isValidPeriodMultiplier">
<xsl:param name="elementName"/>
<xsl:param name="elementValue"/>
<xsl:param name="testNumber"/>
<xsl:param name="context"/>
<xsl:variable name="errorText">Empty or invalid <xsl:value-of select="$elementName"/> element. Value = '<xsl:value-of select="$elementValue"/>'.</xsl:variable>

<xsl:choose>
<xsl:when test="not(contains($elementValue,'.'))">
<xsl:if test="string(number($elementValue)) ='NaN'">
<error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error>
</xsl:if>
</xsl:when>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>
</xsl:template>


<xsl:template name="isValidProductType">
<xsl:param name="elementName"/>
<xsl:param name="elementValue"/>
<xsl:param name="testNumber"/>
<xsl:param name="context"/>

<xsl:variable name="errorText">Empty or invalid <xsl:value-of select="$elementName"/> element when SWDML version = "<xsl:value-of select="$version"/>". Value = '<xsl:value-of select="$elementValue"/>'.</xsl:variable>
<xsl:if test="$version='4-2'">
<xsl:choose>
<xsl:when test="$elementValue='Index Variance Swap'"/>
<xsl:when test="$elementValue='Share Variance Swap'"/>
<xsl:when test="$elementValue='Equity Share Option'"/>
<xsl:when test="$elementValue='Equity Index Option'"/>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>
</xsl:if>

</xsl:template>


<xsl:template name="isValidRateSource">
<xsl:param name="elementName"/>
<xsl:param name="elementValue"/>
<xsl:param name="testNumber"/>
<xsl:param name="context"/>

<xsl:variable name="errorText">Empty or invalid <xsl:value-of select="$elementName"/> element. Value = '<xsl:value-of select="$elementValue"/>'.</xsl:variable>
<xsl:choose>
<xsl:when test="$elementValue='Reuters'"/>
<xsl:when test="$elementValue='Telerate'"/>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>

</xsl:template>


<xsl:template name="isValidRateSourcePage">
<xsl:param name="elementName"/>
<xsl:param name="elementValue"/>
<xsl:param name="testNumber"/>
<xsl:param name="context"/>

<xsl:variable name="errorText">Empty or invalid <xsl:value-of select="$elementName"/> element. Value = '<xsl:value-of select="$elementValue"/>'.</xsl:variable>
<xsl:choose>
<xsl:when test="$elementValue='TAIFX1'"/>
<xsl:when test="$elementValue='HKD='"/>
<xsl:when test="$elementValue='KRW='"/>
<xsl:when test="$elementValue='INR='"/>
<xsl:when test="$elementValue='MYR='"/>
<xsl:when test="$elementValue='NZD='"/>
<xsl:when test="$elementValue='IDR01'"/>
<xsl:when test="$elementValue='THBDFIX=ABSG'"/>
<xsl:when test="$elementValue='SIBP'"/>
<xsl:when test="$elementValue='HSRA'"/>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>

</xsl:template>

<xsl:template name="isValidReferenceCurrency">
<xsl:param name="elementName"/>
<xsl:param name="elementValue"/>
<xsl:param name="testNumber"/>
<xsl:param name="context"/>
<xsl:variable name="errorText">Empty or invalid <xsl:value-of select="$elementName"/> element. Value = '<xsl:value-of select="$elementValue"/>'.</xsl:variable>

<xsl:choose>
<xsl:when test="$elementValue='AUD'"/>
<xsl:when test="$elementValue='HKD'"/>
<xsl:when test="$elementValue='IDR'"/>
<xsl:when test="$elementValue='INR'"/>
<xsl:when test="$elementValue='KRW'"/>
<xsl:when test="$elementValue='MYR'"/>
<xsl:when test="$elementValue='NZD'"/>
<xsl:when test="$elementValue='SGD'"/>
<xsl:when test="$elementValue='THB'"/>
<xsl:when test="$elementValue='TWD'"/>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>

</xsl:template>


<xsl:template name="isValidTime">
<xsl:param name="elementName"/>
<xsl:param name="elementValue"/>
<xsl:param name="testNumber"/>
<xsl:param name="context"/>
<xsl:variable name="errorText">Missing, empty or invalid <xsl:value-of select="$elementName"/>. Value = '<xsl:value-of select="$elementValue"/>'.</xsl:variable>

<xsl:choose>
<xsl:when test="$elementValue='10:00:00'"/>
<xsl:when test="$elementValue='11:30:00'"/>
<xsl:when test="$elementValue='14:10:00'"/>
<xsl:when test="$elementValue='14:15:00'"/>
<xsl:when test="$elementValue='14:45:00'"/>
<xsl:when test="$elementValue='15:15:00'"/>
<xsl:when test="$elementValue='16:00:00'"/>
<xsl:when test="$elementValue='16:30:00'"/>
<xsl:when test="$elementValue='17:00:00'"/>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>
</xsl:template>

<xsl:template name="isValidDefaultSettlementMethod">
<xsl:param name="elementName"/>
<xsl:param name="elementValue"/>
<xsl:param name="testNumber"/>
<xsl:param name="context"/>
<xsl:variable name="errorText">Empty or invalid <xsl:value-of select="$elementName"/> element. Value = '<xsl:value-of select="$elementValue"/>'.</xsl:variable>

<xsl:choose>
<xsl:when test="$elementValue='Cash'"/>
<xsl:when test="$elementValue='Physical'"/>
<xsl:otherwise><error><context><xsl:value-of select="$context"/></context><text>*** <xsl:value-of select="$errorText"/></text></error></xsl:otherwise>
</xsl:choose>

</xsl:template>
</xsl:stylesheet>
